@data InferredClock begin
    Inferred(UUID)
    InferredDiscrete(Int)
end

Moshi.Derive.@derive InferredClock[Show]

const InferredTimeDomain = InferredClock.Type
using .InferredClock: Inferred, InferredDiscrete

function InferredClock.Inferred()
    return Inferred(uuid4())
end

function InferredClock.InferredDiscrete()
    return InferredDiscrete(0)
end

Base.Broadcast.broadcastable(x::InferredTimeDomain) = Ref(x)

"""
    $TYPEDSIGNATURES

Check if the given value is a concrete clock. Any subtype of `SciMLBase.AbstractClock` is
considered concrete. Other types may be used to refer to inferred clocks.
"""
is_concrete_time_domain(::TimeDomain) = true
is_concrete_time_domain(_) = false

function get_time_domain(x::SymbolicT)
    @match x begin
        BSImpl.Term(; f, args) && if f isa SU.Operator && is_timevarying_operator(f)::Bool end => output_timedomain(f, args)
        _ => getmetadata(x, MTKBase.VariableTimeDomain, nothing)
    end
end
get_time_domain(x::Num) = get_time_domain(SU.unwrap(x))

"""
    has_time_domain(x)

Determine if variable `x` has a time-domain attributed to it.
"""
function has_time_domain(x::SymbolicT)
    SU.getmetadata(x, MTKBase.VariableTimeDomain, nothing) !== nothing
end
has_time_domain(x::Num) = has_time_domain(SU.unwrap(x))
has_time_domain(x) = false

"""
    $TYPEDEF

The eltype of the `Vector` returned from [`input_timedomain`](@ref).
"""
const InputTimeDomainElT = Union{TimeDomain, InferredTimeDomain, MTKBase.IntegerSequence}

const IOTimeDomainArgsT = Union{SU.ArgsT{VartypeT}, Nothing}

"""
    input_timedomain(op::Operator, args::Union{SymbolicUtils.ArgsT{Symbolics.VartypeT}, Nothing} = nothing)

Return the time-domain types (`ContinuousClock()` or `InferredDiscrete()`) that `op` operates on.
"""
function input_timedomain end

function input_timedomain(::Symbolics.Differential, ::IOTimeDomainArgsT = nothing)
    InputTimeDomainElT[SciMLBase.ContinuousClock()]
end
output_timedomain(::Symbolics.Differential, ::IOTimeDomainArgsT = nothing) = SciMLBase.ContinuousClock()

"""
    $TYPEDSIGNATURES

Query the `input_timedomain` of the given symbolic.
"""
function input_timedomain(x::SymbolicT)
    @match x begin
        BSImpl.Term(; f, args) && if f isa SU.Operator end => input_timedomain(f, args)
        _ => throw(ArgumentError("$x of type $(typeof(x)) is not an operator expression"))
    end
end

"""
    output_timedomain(op::Operator, args::SymbolicUtils.ArgsT{Symbolics.VartypeT})

Return the time-domain type (`ContinuousClock()` or `InferredDiscrete()`) that `op` results in.
"""
function output_timedomain end

"""
    $TYPEDSIGNATURES

Query the `output_timedomain` of the given symbolic.
"""
function output_timedomain(x::SymbolicT)
    @match x begin
        BSImpl.Term(; f, args) && if f isa SU.Operator end => output_timedomain(f, args)
        _ => throw(ArgumentError("$x of type $(typeof(x)) is not an operator expression"))
    end
end

function input_timedomain(::MTKBase.Shift, args::IOTimeDomainArgsT = nothing)
    if args !== nothing
        arg = args[1]
        if has_time_domain(arg)
            return InputTimeDomainElT[get_time_domain(arg)]
        end
    end
    InputTimeDomainElT[InferredDiscrete()]
end

output_timedomain(::MTKBase.Shift, ::IOTimeDomainArgsT = nothing) = InferredDiscrete()

"""
    $(TYPEDSIGNATURES)

Trait to be implemented for operators which determines whether the operator is applied to
a time-varying quantity and results in a time-varying quantity. For example, `Initial` and
`Pre` are not time-varying since while they are applied to variables, the application
results in a non-discrete-time parameter. `Differential`, `Shift`, `Sample` and `Hold` are
all time-varying operators. All time-varying operators must implement `input_timedomain` and
`output_timedomain`.
"""
is_timevarying_operator(x) = is_timevarying_operator(typeof(x))
is_timevarying_operator(::Type{<:SU.Operator}) = true
is_timevarying_operator(::Type{MTKBase.Initial}) = false
is_timevarying_operator(::Type{MTKBase.Pre}) = false
is_timevarying_operator(::Type) = false

"""
    $(TYPEDSIGNATURES)

Trait to be implemented for operators which determines whether application of the operator
generates a semantically different variable or not. For example, `Differential` and `Shift`
are not transparent but `Sample` and `Hold` are. Defaults to `false` if not implemented.
"""
is_transparent_operator(x) = is_transparent_operator(typeof(x))
is_transparent_operator(::Type) = false
is_transparent_operator(::Type{MTKBase.Sample}) = true
is_transparent_operator(::Type{MTKBase.Hold}) = true

"""
    $TYPEDSIGNATURES

The rate at which a clock samples.
"""
sampletime(c) = Moshi.Match.@match c begin
    x::SciMLBase.AbstractClock => nothing
    SciMLBase.PeriodicClock(dt) => dt
    _ => nothing
end

sampletime(op::MTKBase.Sample, _ = nothing) = sampletime(op.clock)
sampletime(op::MTKBase.ShiftIndex, _ = nothing) = sampletime(op.clock)

"""
Handle renaming variable names for discrete structural simplification. Three cases: 
- positive shift: do nothing
- zero shift: x(t) => Shift(t, 0)(x(t))
- negative shift: rename the variable
"""
function lower_shift_varname(var, iv)
    op = operation(var)
    if op isa Shift
        return MTKBase.shift2term(var)
    else
        return Shift(iv, 0)(var, true)
    end
end

shift2term_with_unit(x, t) = MTKBase._with_unit(MTKBase.shift2term, x, t)
lower_shift_varname_with_unit(var, iv) = MTKBase._with_unit(lower_shift_varname, var, iv, iv)
function descend_lower_shift_varname_with_unit(var, iv)
    symbolic_type(var) === NotSymbolic() && return var
    MTKBase._with_unit(descend_lower_shift_varname, var, iv, iv)
end
function descend_lower_shift_varname(var, iv)
    @match var begin
        BSImpl.Term(; f, args) && if f isa Shift end => MTKBase.shift2term(var)
        if iscall(var) end => begin
            args = arguments(var)
            _args = SU.ArgsT{VartypeT}()
            sizehint!(_args, length(args))
            for arg in args
                push!(_args, descend_lower_shift_varname(arg, iv))
            end
            return SU.maketerm(SymbolicT, operation(var), _args, SU.metadata(var))
        end
        _ => return var
    end
end

function is_time_dependent_parameter(p::SymbolicT, allps::Set{SymbolicT}, iv::SymbolicT)
    return p in allps && @match p begin
        BSImpl.Term(; f, args) => begin
            farg = args[1]
            f === getindex && is_time_dependent_parameter(farg, allps, iv) ||
                length(args) == 1 && isequal(farg, iv)
        end
        _ => false
    end
end

const UNION_SPLIT_VAR_FIRST_ERR = """
The first argument to `@union_split_var` must be of the form `var::Union{T1, T2}` where \
`var` is a single variable (not an expression).
"""

"""
    @union_split_var var::Union{T1, T2} begin; #= ... =#; end

Manually dispatch the `begin..end` block based on the given type-annotation for `var`.
`var` cannot be an expression.
"""
macro union_split_var(annotated_var::Expr, block::Expr)
    @assert Meta.isexpr(annotated_var, :(::)) UNION_SPLIT_VAR_FIRST_ERR
    @assert length(annotated_var.args) == 2 UNION_SPLIT_VAR_FIRST_ERR
    var, type = annotated_var.args
    @assert var isa Symbol UNION_SPLIT_VAR_FIRST_ERR
    var = var::Symbol
    @assert Meta.isexpr(type, :curly) UNION_SPLIT_VAR_FIRST_ERR
    @assert type[1] == :Union UNION_SPLIT_VAR_FIRST_ERR

    variants = @view type.args[2:end]
    N = length(variants)
    expr = Expr(:if)
    cur_expr = expr
    for (i, variant) in enumerate(variants)
        push!(cur_expr.args, :($var isa $variant))
        push!(cur_expr.args, block)
        i == N && continue
        new_expr = Expr(:elseif)
        push!(cur_expr.args, new_expr)
        cur_expr = new_expr
    end
    push!(cur_expr.args, :(error("Unexpected type $(typeof($var)) for variable $($var)")))

    return esc(expr)
end

"""
    $TYPEDSIGNATURES

Debugging tool useful for comparing two `SystemStructure`s. Return a copy of `structure` with
variables reordered according to `oldtonewvar` and equations according to `oldtoneweq`.
"""
function permute(structure::SystemStructure, oldtonewvar::Vector{Int}, oldtoneweq::Vector{Int})
    graph = BipartiteGraph(nsrcs(structure.graph), ndsts(structure.graph))
    for e in 𝑠vertices(structure.graph)
        for v in 𝑠neighbors(structure.graph, e)
            add_edge!(graph, oldtoneweq[e], oldtonewvar[v])
        end
    end
    solvable_graph = BipartiteGraph(nsrcs(structure.solvable_graph), ndsts(structure.solvable_graph))
    for e in 𝑠vertices(structure.solvable_graph)
        for v in 𝑠neighbors(structure.solvable_graph, e)
            add_edge!(solvable_graph, oldtoneweq[e], oldtonewvar[v])
        end
    end
    var_to_diff = StateSelection.DiffGraph(ndsts(graph))
    for i in 𝑑vertices(structure.graph)
        if structure.var_to_diff[i] isa Int
            var_to_diff[oldtonewvar[i]] = oldtonewvar[structure.var_to_diff[i]]
        end
    end
    eq_to_diff = StateSelection.DiffGraph(nsrcs(graph))
    for i in 𝑠vertices(structure.graph)
        if structure.eq_to_diff[i] isa Int
            eq_to_diff[oldtoneweq[i]] = oldtoneweq[structure.eq_to_diff[i]]
        end
    end

    var_types = similar(structure.var_types)
    sps = similar(structure.state_priorities)
    for i in 𝑑vertices(structure.graph)
        var_types[oldtonewvar[i]] = structure.var_types[i]
        sps[oldtonewvar[i]] = structure.state_priorities[i]
    end

    return SystemStructure(var_to_diff, eq_to_diff, graph, solvable_graph, var_types, sps, structure.only_discrete)
end

"""
    $TYPEDSIGNATURES

Debugging tool useful for comparing two `TearingState`s. Return a copy of `ts` with
variables reordered according to `oldtonewvar` and equations according to `oldtoneweq`.
"""
function permute(ts::TearingState, oldtonewvar::Vector{Int}, oldtoneweq::Vector{Int})
    structure = permute(ts.structure, oldtonewvar, oldtoneweq)
    fullvars = similar(ts.fullvars)
    always_present = similar(ts.always_present)
    for i in eachindex(fullvars)
        fullvars[oldtonewvar[i]] = ts.fullvars[i]
        always_present[oldtonewvar[i]] = ts.always_present[i]
    end
    original_eqs = similar(ts.original_eqs)
    eqs_source = similar(ts.eqs_source)
    eqs = collect(equations(ts))
    for i in eachindex(original_eqs)
        original_eqs[oldtoneweq[i]] = ts.original_eqs[i]
        eqs_source[oldtoneweq[i]] = ts.eqs_source[i]
        eqs[oldtoneweq[i]] = equations(ts)[i]
    end
    
    sys = ts.sys
    @set! sys.eqs = eqs
    @set! sys.unknowns = fullvars
    return TearingState(sys, fullvars, structure, Equation[], ts.param_derivative_map, ts.no_deriv_params, original_eqs, ts.additional_observed, always_present, ts.statemachines, eqs_source)
end

"""
    $TYPEDSIGNATURES

Debugging tool useful for comparing two `SparseMatrixCLIL`s. Return a copy of `mm` with
variables reordered according to `oldtonewvar` and equations according to `oldtoneweq`.
"""
function permute(mm::StateSelection.SparseMatrixCLIL{S, T}, oldtonewvar::Vector{Int}, oldtoneweq::Vector{Int}) where {S, T}
    nzrows = copy(mm.nzrows)
    rowcols = copy(mm.row_cols)
    rowvals = copy(mm.row_vals)
    for i in eachindex(nzrows)
        nzrows[i] = oldtoneweq[nzrows[i]]
        for j in eachindex(rowcols[i])
            rowcols[i][j] = oldtonewvar[rowcols[i][j]]
        end
        perm = sortperm(rowcols[i])
        rowcols[i] = rowcols[i][perm]
        rowvals[i] = rowvals[i][perm]
    end

    return StateSelection.SparseMatrixCLIL{S, T}(mm.nparentrows, mm.ncols, nzrows, rowcols, rowvals)
end

"""
    $TYPEDEF

Thrown by [`BoundedIO`](@ref) when the byte limit is reached.
"""
struct BoundedIOOverflow <: Exception end

"""
    $TYPEDEF

An `IO` wrapper that throws [`BoundedIOOverflow`](@ref) once more than
`remaining` bytes have been written to it. Printing a symbolic expression
produces output proportional to its *tree* size, which is exponential in the
sharing depth of the hash-consed DAG; since printing streams depth-first,
aborting after a bounded number of bytes also bounds the traversal work.
"""
mutable struct BoundedIO{T <: IO} <: IO
    io::T
    remaining::Int
end

function Base.write(io::BoundedIO, b::UInt8)
    io.remaining <= 0 && throw(BoundedIOOverflow())
    io.remaining -= 1
    return write(io.io, b)
end

# Without this, bulk writes (e.g. printing a `String`) fall back to Base's
# generic byte-at-a-time `unsafe_write`. Mirror what `LimitIO` does: write the
# whole chunk at once, filling exactly up to the limit before aborting.
function Base.unsafe_write(io::BoundedIO, p::Ptr{UInt8}, nb::UInt)
    if nb > io.remaining
        if io.remaining > 0
            unsafe_write(io.io, p, io.remaining % UInt)
            io.remaining = 0
        end
        throw(BoundedIOOverflow())
    end
    nw = unsafe_write(io.io, p, nb)
    io.remaining -= nw
    return nw
end

"""
    $TYPEDSIGNATURES

`string(x)`, truncated to at most `limit` bytes of output. The truncation also
bounds the printing work, making this safe to call on expressions whose full
printed form would be astronomically large.
"""
function bounded_string(x, limit::Int)
    buf = IOBuffer(; sizehint = limit)
    try
        print(BoundedIO(buf, limit), x)
    catch err
        err isa BoundedIOOverflow || rethrow()
    end
    return String(take!(buf))
end

@noinline unimplemented() = error("This must be implemented for clock inference!")

get_sys(state::StateSelection.TransformationState) = state.sys

"""
    $TYPEDSIGNATURES

Perform any necessary postprocessing given the reult of clock inference `ci` and the
associated transformation state. Return the new `ci`.
"""
function postprocess_clock_inference(ci::ClockInference{T}, state::T) where {T <: StateSelection.TransformationState}
    ci
end

"""
    $TYPEDSIGNATURES

Given the `state` for the hybrid system, return the transformation state for the subset
of the system composed of equations `ieqs`, initialization equations `iieqs` and variables
`ivars`.
"""
function system_subset(state::StateSelection.TransformationState, ieqs::Vector{Int},
                       iieqs::Vector{Int}, ivars::Vector{Int})
    unimplemented()
end

"""
    $TYPEDSIGNATURES

Given the `state` obtained via [`system_subset`](@ref), mark it as discrete and return the
updated transformation state. Mutation of the existing `state` is allowed.
"""
function mark_discrete(state::StateSelection.TransformationState)
    unimplemented()
end

function error_sample_time(eq)
    error("$eq\ncontains `SampleTime` but it is not an Inferred discrete equation.")
end
function substitute_sample_time(ci::ClockInference{TearingState}, ts::TearingState)
    eq_domain = ci.eq_domain
    eqs = copy(equations(ts))
    @assert length(eqs) == length(eq_domain)
    subrules = Dict{SymbolicT, SymbolicT}()
    st = SampleTime()
    for i in eachindex(eqs)
        eq = eqs[i]
        domain = eq_domain[i]
        dt = SU.Const{VartypeT}(sampletime(domain))
        if dt === MTKBase.COMMON_NOTHING
            if SU.query(isequal(st), eq.lhs) || SU.query(isequal(st), eq.rhs)
                error_sample_time(eq)
            end
            neweq = eq
        else
            subrules[st] = dt
            neweq = substitute(eq, subrules)
        end
        eqs[i] = neweq
    end
    @set! ts.sys.eqs = eqs
    @set! ci.ts = ts
end

function system_subset(ts::TearingState, ieqs::Vector{Int}, iieqs::Vector{Int}, ivars::Vector{Int})
    eqs = equations(ts)
    initeqs = initialization_equations(ts.sys)
    @set! ts.sys.eqs = eqs[ieqs]
    @set! ts.sys.initialization_eqs = initeqs[iieqs]
    @set! ts.original_eqs = ts.original_eqs[ieqs]
    @set! ts.structure = system_subset(ts.structure, ieqs, ivars)
    @set! ts.always_present = ts.always_present[ivars]
    if !isempty(ts.eqs_source)
        @set! ts.eqs_source = ts.eqs_source[ieqs]
    end
    if all(eq -> eq.rhs isa StateMachineOperator, MTKBase.get_eqs(ts.sys))
        names = Symbol[]
        for eq in MTKBase.get_eqs(ts.sys)
            if eq.lhs isa Transition
                push!(names, first(MTKBase.namespace_hierarchy(nameof(eq.rhs.from))))
                push!(names, first(MTKBase.namespace_hierarchy(nameof(eq.rhs.to))))
            elseif eq.lhs isa InitialState
                push!(names, first(MTKBase.namespace_hierarchy(nameof(eq.rhs.s))))
            else
                error("Unhandled state machine operator")
            end
        end
        @set! ts.statemachines = filter(x -> nameof(x) in names, ts.statemachines)
    else
        @set! ts.statemachines = eltype(ts.statemachines)[]
    end
    @set! ts.fullvars = ts.fullvars[ivars]
    ts
end

function system_subset(structure::SystemStructure, ieqs::Vector{Int}, ivars::Vector{Int})
    graph = structure.graph
    fadj = Vector{Int}[]
    eq_to_diff = StateSelection.DiffGraph(length(ieqs))
    var_to_diff = StateSelection.DiffGraph(length(ivars))

    ne = 0
    old_to_new_var = zeros(Int, ndsts(graph))
    for (i, iv) in enumerate(ivars)
        old_to_new_var[iv] = i
    end
    for (i, iv) in enumerate(ivars)
        structure.var_to_diff[iv] === nothing && continue
        var_to_diff[i] = old_to_new_var[structure.var_to_diff[iv]]
    end
    for (j, eq_i) in enumerate(ieqs)
        var_adj = [old_to_new_var[i] for i in graph.fadjlist[eq_i]]
        @assert all(!iszero, var_adj)
        ne += length(var_adj)
        push!(fadj, var_adj)
        eq_to_diff[j] = structure.eq_to_diff[eq_i]
    end
    @set! structure.graph = complete(BipartiteGraph(ne, fadj, length(ivars)))
    @set! structure.eq_to_diff = eq_to_diff
    @set! structure.var_to_diff = complete(var_to_diff)
    @set! structure.state_priorities = structure.state_priorities[ivars]
    @set! structure.var_types = structure.var_types[ivars]
    structure
end

function mark_discrete(state::TearingState)
    state = shift_discrete_system(state)
    @set! state.structure.only_discrete = true
    return state
end

"""
    is_discrete_domain(x)

true if `x` contains only discrete-domain signals.
See also [`has_discrete_domain`](@ref)
"""
function is_discrete_domain(x)
    if hasmetadata(x, VariableTimeDomain) || issym(x)
        return is_discrete_time_domain(getmetadata(x, VariableTimeDomain, false))
    end
    !has_discrete_domain(x) && has_continuous_domain(x)
end

"""
    is_hybrid_domain(x)

true if `x` contains both discrete and continuous-domain signals. `x` may be an expression or equation.
"""
is_hybrid_domain(x) = has_discrete_domain(x) && has_continuous_domain(x)

"""
    has_discrete_domain(x)

true if `x` contains discrete signals (`x` may or may not contain continuous-domain signals). `x` may be an expression or equation.
See also [`is_discrete_domain`](@ref)
"""
function has_discrete_domain(x)
    issym(x) && return is_discrete_domain(x)
    hasshift(x) || hassample(x) || hashold(x)
end

"""
    has_continuous_domain(x)

true if `x` contains continuous signals (`x` may or may not contain discrete-domain signals). `x` may be an expression or equation.
See also [`is_continuous_domain`](@ref)
"""
function has_continuous_domain(x)
    issym(x) && return is_continuous_domain(x)
    hasderiv(x) || hassample(x) || hashold(x)
end

"""
    is_continuous_domain(x)

true if `x` contains only continuous-domain signals.
See also [`has_continuous_domain`](@ref)
"""
function is_continuous_domain(x)
    issym(x) && return getmetadata(x, VariableTimeDomain, false) == ContinuousClock()
    !has_discrete_domain(x) && has_continuous_domain(x)
end

"""
    $(TYPEDEF)

Description of a single *inline linear-solve block* in a simplified system: a
square linear system ``A x = b`` that the generated code re-solves on every
evaluation. The tearing/reassemble pass emits such a block when it solves a
strongly-connected component of algebraic equations as one linear system,
writing each solved variable as an assignment `vᵢ ~ (A \\ b)[i]`.

# Fields

$(TYPEDFIELDS)

See [`inline_linear_systems`](@ref).
"""
struct InlineLinearSystem
    "Dimension `N` of the square `N×N` linear system."
    size::Int
    """
    The variables solved by the block, ordered by their index in the solution
    vector. An entry is `nothing` if that solution component is not assigned to a
    variable (it should not normally occur).
    """
    variables::Vector{SymbolicT}
    """
    The symbolic solve expression `A \\ b` (its `arguments` are the coefficient
    matrix `A` and the right-hand side `b`), retained so callers can inspect or
    numerically evaluate `A`, e.g. to check its conditioning.
    """
    expression::SymbolicT
end

function Base.show(io::IO, blk::InlineLinearSystem)
    print(io, blk.size, "×", blk.size, " ", nameof(operation(blk.expression)), " block")
end

function Base.show(io::IO, ::MIME"text/plain", blk::InlineLinearSystem)
    println(io, blk.size, "×", blk.size, " inline linear system (",
            nameof(operation(blk.expression)), ") solving:")
    for (i, v) in enumerate(blk.variables)
        println(io, "  [", i, "] ", v === nothing ? "(unassigned)" : v)
    end
end

# Metadata key under which the reassemble pass records the `InlineLinearSystem`
# blocks it emits (see `generate_system_equations!` in `reassemble.jl`).
struct InlineLinearSystemsMetadata end

"""
    $(TYPEDSIGNATURES)

Report the inline linear-solve blocks in the simplified system `sys` as a
`Vector{`[`InlineLinearSystem`](@ref)`}`, sorted by decreasing size.

When tearing solves a strongly-connected component of algebraic equations as one
linear system, it emits, into `equations(sys)` / `observed(sys)`, a square system
``A x = b`` that the generated code re-solves on every evaluation as `A \\ b`. Each
solution component `i` then appears as an assignment `vᵢ ~ (A \\ b)[i]`. The
reassemble pass records these blocks in the system metadata as it creates them, and
this function simply reads them back.

For each block it reports its size `N` and the `N` variables it solves for. It is a
diagnostic for understanding a compiled model's per-step cost and structure: large
blocks are the dominant linear-algebra work each evaluation, and a singularity-prone
block can be traced to the physical quantities it determines. Returns an empty vector
when `sys` emits no inline linear solves.
"""
function inline_linear_systems(sys::MTKBase.AbstractSystem)
    return SU.getmetadata(sys, InlineLinearSystemsMetadata, InlineLinearSystem[])::Vector{InlineLinearSystem}
end

function StateSelection.possibly_explicit_equations(state::TearingState)
    var2idx = Dict{SymbolicT, Int}()
    for i in eachindex(state.fullvars)
        var2idx[state.fullvars[i]] = i
    end
    filterfn = let state = state, var2idx = var2idx, sys_eqs = equations(state)
        function _filterfn(i::Int)
            eq = state.original_eqs[i]
            lhs = eq.lhs
            rhs = eq.rhs
            sys_eq = sys_eqs[i]
            slhs = sys_eq.lhs
            srhs = sys_eq.rhs
            return haskey(var2idx, lhs) && !MTKBase.isirreducible(lhs) &&
                !(SU._iszero(slhs) && SU._iszero(srhs)) && !SU.query(isequal(lhs), rhs)
        end
    end
    mapfn = let state = state, var2idx = var2idx
        function _mapfn(i::Int)
            (i, var2idx[state.original_eqs[i].lhs])
        end
    end
    return Iterators.map(mapfn, Iterators.filter(filterfn, eachindex(state.original_eqs)))
end

function StateSelection.trivial_tearing_postprocess!(ts::TearingState, torn_eqs::Vector{Int}, torn_vars::Vector{Int})
    append!(ts.additional_observed, @view ts.original_eqs[torn_eqs])
    return ts
end

module ModelingToolkitTearing

using DocStringExtensions
import StateSelection
using ModelingToolkitBase
import ModelingToolkitBase as MTKBase
using BipartiteGraphs
using Symbolics
using SymbolicUtils
import SymbolicUtils as SU
using Moshi.Match: @match
using Moshi.Data: @data
import Moshi
using OrderedCollections
using Setfield: @set!, @set
using Graphs
import SciMLBase
import SymbolicIndexingInterface as SII
using SymbolicIndexingInterface
import CommonSolve
import SparseArrays

using StateSelection: SelectedState, CLIL
using ModelingToolkitBase: VariableType, VARIABLE, BROWNIAN, complete, observed
using Symbolics: SymbolicT, VartypeT
using SymbolicUtils: BSImpl, unwrap
using SciMLBase: LinearProblem
using SparseArrays: nonzeros
import LinearAlgebra
import UUIDs: UUID, uuid4

const TimeDomain = SciMLBase.AbstractClock

include("tearingstate.jl")
include("utils.jl")
include("stateselection_interface.jl")
include("trivial_tearing_interface.jl")

"""
    $TYPEDEF

Supertype for all reassembling algorithms. A reassembling algorithm takes as input the
`TearingState`, `TearingResult` and integer incidence matrix
`mm::StateSelection.CLIL.SparseMatrixCLIL`. The matrix `mm` may be `nothing`. The
algorithm must also accept arbitrary keyword arguments. The following keyword arguments
will always be provided:

- `fully_determined::Bool`: flag indicating whether the system is fully determined.

The output of a reassembling algorithm must be the torn system.

A reassemble algorithm must also implement `with_fully_determined`
"""
abstract type ReassembleAlgorithm end

export inline_linear_systems, InlineLinearSystem
include("diagnostics.jl")

include("reassemble.jl")

struct UnhackSystemCacheKey end

function MTKBase.should_invalidate_mutable_cache_entry(::Type{UnhackSystemCacheKey}, patch::NamedTuple)
    return true
end

function MTKBase.unhack_system(sys::System)
    cached_sys = MTKBase.check_mutable_cache(sys, UnhackSystemCacheKey, System, nothing)
    if cached_sys isa System
        return cached_sys
    end
    # Observed are copied by the masking operation
    obseqs = observed(sys)
    eqs = copy(equations(sys))
    obs_mask = trues(length(obseqs))
    for (i, eq) in enumerate(obseqs)
        obs_mask[i] = @match eq.rhs begin
            BSImpl.Term(; f, args) => if f === change_origin
                false
            elseif f === SU.array_literal
                result = true
                for (si, ai) in zip(SU.stable_eachindex(eq.lhs), Iterators.drop(eachindex(args), 1))
                    result &= isequal(eq.lhs[si], args[ai])
                    result || break
                end
                !result
            else
                true
            end
            _ => true
        end
    end
    obseqs = obseqs[obs_mask]

    # Map from ldiv operation to index of the equations where it is the RHS. A
    # positive index is into `obseqs`, a negative index is into `eqs`. The variable
    # order for the ldiv comes from the LHS of the corresponding equations.
    inline_linear_scc_map = Dict{SymbolicT, Vector{Int}}()

    for (i, eq) in enumerate(obseqs)
        populate_inline_scc_map!(inline_linear_scc_map, eq, i, false)
    end
    for (i, eq) in enumerate(eqs)
        populate_inline_scc_map!(inline_linear_scc_map, eq, i, true)
    end

    # Now, we want to turn all inlined linear SCCs into algebraic equations. If an element
    # of the SCC is a differential variable, we'll introduce the `toterm` as a new algebraic.
    # Otherwise, the observed equation is removed.
    resize!(obs_mask, length(obseqs))
    fill!(obs_mask, true)
    additional_eqs = Equation[]
    additional_vars = Set{SymbolicT}()
    additional_subs = Dict{SymbolicT, SymbolicT}()

    # Also need to update schedule
    sched = MTKBase.get_schedule(sys)
    if sched isa MTKBase.Schedule
        sched = copy(sched)
    end
    for (linsolve, idxs) in inline_linear_scc_map
        A, b = @match linsolve begin
            BSImpl.Term(; args) => args
        end
        A_mat = collect(A)::Matrix{SymbolicT}
        b_vec = collect(b)::Vector{SymbolicT}
        N = length(b_vec)
        x = Vector{SymbolicT}(undef, N)
        for (i, idx) in enumerate(idxs)
            is_obs = idx > 0
            idx = abs(idx)
            if is_obs
                var = obseqs[idx].lhs
                x[i] = var
                obs_mask[idx] = false
            else
                var = MTKBase.default_toterm(eqs[idx].lhs)
                if sched isa MTKBase.Schedule
                    sched.dummy_sub[eqs[idx].lhs] = x[i] = var
                end
                eqs[idx] = eqs[idx].lhs ~ var
            end
            push!(additional_vars, var)
            additional_subs[linsolve[i]] = x[i]
        end

        for res_i in linear_scc_residuals(A_mat, b_vec, x)
            SU._iszero(res_i) && continue
            # If a linear SCC contains both `D(w)` and `w_t`, it'll contain the equation `D(w) ~ w_t`.
            # When unhacking it, `D(w)` will be totermed into `w_t`. Avoid adding the `0 ~ 0` equations.
            # The duplicate variables are automatically removed by the `Set`.
            # See https://github.com/SciML/ModelingToolkit.jl/issues/4196 for further details.
            push!(additional_eqs, Symbolics.COMMON_ZERO ~ res_i)
        end
    end
    @assert length(additional_eqs) == length(additional_vars)
    subst = SU.Substituter{false}(additional_subs, SU.default_substitute_filter)
    obseqs = obseqs[obs_mask]
    map!(subst, obseqs, obseqs)
    append!(eqs, additional_eqs)
    map!(subst, eqs, eqs)

    if sched isa MTKBase.Schedule
        map!(subst, values(sched.dummy_sub))
    end

    dvs = [unknowns(sys); collect(additional_vars)]

    newsys = @set sys.observed = obseqs
    @set! newsys.eqs = eqs
    @set! newsys.unknowns = dvs
    @set! newsys.schedule = sched

    MTKBase.store_to_mutable_cache!(sys, UnhackSystemCacheKey, newsys)

    return newsys
end

"""
    $TYPEDSIGNATURES

Compute the residuals `r = A * x - b`.
"""
function linear_scc_residuals(A_mat::Matrix{SymbolicT}, b_vec::Vector{SymbolicT}, x::Vector{SymbolicT})
    N = length(b_vec)
    residuals = Vector{SymbolicT}(undef, N)
    add_buffer = SU.ArgsT{VartypeT}()
    for i in 1:N
        empty!(add_buffer)
        push!(add_buffer, -b_vec[i])
        for j in 1:N
            aij = A_mat[i, j]
            SU._iszero(aij) && continue
            push!(add_buffer, aij * x[j])
        end
        residuals[i] = SU.add_worker(VartypeT, add_buffer)
    end
    return residuals
end

function populate_inline_scc_map!(
    inline_linear_scc_map::Dict{SymbolicT, Vector{Int}},
    eq::Equation, eq_i::Int,
    is_diffeq::Bool)
    is_diffeq && SU.isconst(eq.lhs) && return eq

    ldiv, idx, is_ldiv = maybe_extract_inline_linsolve(eq.rhs)
    is_ldiv || return
    len = length(ldiv)
    buffer = get!(() -> zeros(Int, len), inline_linear_scc_map, ldiv)
    iszero(buffer[idx]) || return
    buffer[idx] = ifelse(is_diffeq, -eq_i, eq_i)
end

function maybe_extract_inline_linsolve(rhs::SymbolicT)
    @match rhs begin
        BSImpl.Term(; f, args) && if f === getindex && length(args) == 2 end => begin
            maybe_ldiv = args[1]
            _idx = args[2]
            @match maybe_ldiv begin
                BSImpl.Term(; f) && if f === INLINE_LINEAR_SCC_OP end => begin
                    return maybe_ldiv, unwrap_const(_idx)::Int, true
                end
                _ => nothing
            end
        end
        _ => nothing
    end
    return Symbolics.COMMON_ZERO, 0, false
end

include("clock_inference/clock.jl")
include("clock_inference/state_machines.jl")
include("clock_inference/clock_inference.jl")
include("clock_inference/interface.jl")


end # module ModelingToolkitTearing

module ModelingToolkitClockInference

using DocStringExtensions
using SymbolicUtils
import SymbolicUtils as SU
using SymbolicUtils: BSImpl
using Symbolics
using Symbolics: SymbolicT, VartypeT
import ModelingToolkitBase as MTKBase
using BipartiteGraphs
import StateSelection
import Moshi.Match: @match
import Moshi.Data: @data
import Moshi
import SciMLBase
using Graphs

const TimeDomain = SciMLBase.AbstractClock

include("clock.jl")
include("clock_inference.jl")
include("interface.jl")

end # module ModelingToolkitClockInference

using Test
using ModelingToolkitTearing
import ModelingToolkitTearing as MTKTearing
using ModelingToolkit
using Symbolics
using BipartiteGraphs
using Graphs
import StateSelection
using ModelingToolkit: t_nounits as t, D_nounits as D
import SymbolicUtils as SU
using SymbolicUtils: unwrap
using Setfield
using ForwardDiff

@testset "`InferredDiscrete` validation" begin
    k = ShiftIndex()
    @variables x(t) y(t)
    @named sys = System([x(k) ~ x(k-1) + x(k-2), D(y) ~ Hold(x) + t], t)
    @test_throws ModelingToolkitTearing.ExpectedDiscreteClockPartitionError mtkcompile(sys)
    @named sys = System([x(k) ~ x(k-1) + x(k-2), D(y) ~ x + t], t)
    @test_throws ModelingToolkitTearing.ExpectedDiscreteClockPartitionError mtkcompile(sys)
end

@testset "`maybe_zeros` is respected" begin
    @variables x(t) y(t)
    @parameters p
    @mtkcompile sys = System([D(x) ~ y, p * y ~ x], t)
    @test issetequal(unknowns(sys), [x])
    @test issetequal(observables(sys), [y])
    @mtkcompile sys = System([D(x) ~ y, p * y ~ x], t; maybe_zeros = Symbolics.SymbolicT[p])
    @test issetequal(unknowns(sys), [x, y])
    @test isempty(observables(sys))
end

# https://github.com/SciML/ModelingToolkit.jl/issues/4282
@testset "`find_eq_solvables!` symbolically removes singular incidences" begin
    @variables x(t) y(t)
    @named sys = System([D(x) ~ 2x, y + 2(x + t) - t * (2x / t - 1) ~ 0], t)
    ts = TearingState(sys; sort_eqs = false)
    @test SU.query(isequal(x), equations(ts)[2].rhs)
    a, b, islin = Symbolics.linear_expansion(equations(ts)[2], x)
    @test SU._iszero(a) && islin
    x_idx = findfirst(isequal(x), ts.fullvars)::Int
    @test Graphs.has_edge(ts.structure.graph, BipartiteEdge(2, x_idx))
    StateSelection.find_solvables!(ts)
    @test !Graphs.has_edge(ts.structure.graph, BipartiteEdge(2, x_idx))
    @test !SU.query(isequal(x), equations(ts)[2].rhs)
end

@testset "Clock inference doesn't only rely on `fullvars` for metadata clock information" begin
    @variables y(t) l(t)
    k = ShiftIndex(Clock(0.1))
    eqs = [
        y(k) ~ -Sample()(l),
        D(l) ~ 20*(Hold()(y) - l)
    ]

    @named cl = System(eqs, t)
    # It should throw this error, not one saying it can't find a clock for an
    # inferreddiscrete partition
    @test_throws ModelingToolkit.HybridSystemNotSupportedException mtkcompile(cl)
end

@testset "`ShiftIndex()` identity is used to propagate clocks" begin
    function Inner1(; name, k)
        @variables wde(t)
        return System([wde(k) ~ 0], t; name)
    end
    function Outer(; name)
        @variables x(t) y(t) z(t)
        k1 = ShiftIndex() # intentionally has no clock
        k2 = ShiftIndex() # different UUID to make sure it is not a hard constraint
        k3 = ShiftIndex(Clock(1 // 10))
        @named inner = Inner1(; k = k1)
        eqs = [
            x(k1) ~ x(k1 - 1) + 1,
            y(k2) ~ y(k2 - 1) + 2,
            # Not `x(k3) + y(k3)` to ensure that `x` and `y` in `TearingState` never have
            # concrete clock metadata.
            z(k3) ~ x + y,
        ]
        return System(eqs, t; systems = [inner], name)
    end
    @named sys = Outer()
    ts = TearingState(sys)
    ci = MTKTearing.ClockInference(ts)
    MTKTearing.infer_clocks!(ci)
    @test all(isequal(Clock(1 // 10)), ci.var_domain)
end

@testset "Clock inference handles unscalarized variables" begin
    @variables x(t)[1:3] y(t)
    k = ShiftIndex(Clock(1 // 10))
    # Intentionally avoid `k` in second equation
    eqs = [x(k) ~ x(k - 1) + x(k - 2), y ~ sum(x)]
    @named sys = System(eqs, t)
    ts = TearingState(sys)
    ci = MTKTearing.ClockInference(ts)
    MTKTearing.infer_clocks!(ci)
    @test all(isequal(Clock(1 // 10)), ci.var_domain)
end

@testset "non-unit integer coefficients are considered solvable" begin
    # https://github.com/SciML/ModelingToolkit.jl/issues/4322
    @variables x(t) y(t)
    eqs = [
        0 ~ x - y
        0 ~ 2y - x
    ]

    @named sys = System(eqs, t)
    sys = mtkcompile(sys)
    @test isempty(unknowns(sys))
    @test length(observed(sys)) == 2
end

@testset "Duals through inline linear SCC DiffCaches" begin
    @variables x(t) y(t) z(t) w(t) q(t)
    reassemble_alg = MTKTearing.DefaultReassembleAlgorithm(; inline_linear_sccs = true)
    @mtkcompile sys = System(
        [
            D(x) ~ 2t + 1,
            t * y + x * z + w ~ 4,
            4y + 3z + 2w ~ 7,
            2x * y + 3t * z + w ~ 10,
            D(q) ~ 2w,
        ],
        t
    ) reassemble_alg = reassemble_alg

    prob = ODEProblem(sys, [x => 1, q => 1], (0.0, 1.0); guesses = [x => 1, y => 1, z => 1, w => 1, q => 1])

    buffer = similar(prob.u0)
    @test_nowarn ForwardDiff.jacobian(buffer, prob.u0) do du, u
        @test eltype(u) <: ForwardDiff.Dual
        prob.f.f.f_iip(du, u, prob.p, 1.0)
    end
    @test_nowarn ForwardDiff.derivative(buffer, 1.2) do du, t
        @test t isa ForwardDiff.Dual
        prob.f.f.f_iip(du, prob.u0, prob.p, t)
    end
end

@testset "`inline_linear_systems` diagnostic" begin
    @variables x(t) y(t) z(t) w(t) q(t)
    ralg = MTKTearing.DefaultReassembleAlgorithm(; inline_linear_sccs = true)
    # The algebraic SCC (y, z, w) is solved as one inline linear system.
    @mtkcompile sys = System(
        [
            D(x) ~ 2t + 1,
            t * y + x * z + w ~ 4,
            4y + 3z + 2w ~ 7,
            2x * y + 3t * z + w ~ 10,
            D(q) ~ 2w,
        ],
        t
    ) reassemble_alg = ralg

    blocks = inline_linear_systems(sys)
    @test length(blocks) == 1
    blk = only(blocks)
    @test blk isa InlineLinearSystem
    @test blk.size == 3
    @test length(blk.variables) == blk.size
    @test issetequal(blk.variables, [y, z, w])
    # the retained expression is the solve term `A \ b`
    @test SU.operation(unwrap(blk.expression)) === MTKTearing.INLINE_LINEAR_SCC_OP
    @test length(SU.arguments(unwrap(blk.expression))) == 2

    # a system with no inline linear solve yields no blocks
    @mtkcompile sys2 = System([D(x) ~ x], t)
    @test isempty(inline_linear_systems(sys2))
end

@testset "`find_eq_solvables!` with `may_be_zero = true` doesn't push 0 elements to `coeffs`" begin
    @variables x y z
    @named sys = System([x + y + z ~ 0])
    ts = TearingState(sys)
    # Artificially remove symbolic incidence
    @set! ts.sys.eqs = [0 ~ -x]
    ts.structure.solvable_graph = BipartiteGraph(1, 3)
    to_rm = Int[]
    coeffs = Int[]
    StateSelection.find_eq_solvables!(ts, 1, to_rm, coeffs)
    @test issetequal(ts.fullvars[to_rm], [y, z])
    # Previously, this would have zeros corresponding to `y` and `z`, and yet the incidence for those
    # variables is removed from `ts.structure.graph`. This would cause incorrect values in `linear_subsys_adjmat!`
    @test coeffs == [-1]
end

@testset "Inline linear SCC uses strict form of `linear_expansion`" begin
    @variables x(t) y(t) z(t) w(t) p(t)
    # Without strict form, the `ifelse` is considered linear in `z`
    @test_nowarn @mtkcompile sys = System(
        [
            D(x) ~ 2x + t
            y + 2z + 3w ~ 4
            2y + 4ifelse(z < 0, 2z, 3z) + 7w ~ 12
            3y - 2z + 5w ~ 13
            D(p) ~ 2y + 3w + z
        ], t
    ) reassemble_alg = MTKTearing.DefaultReassembleAlgorithm(; inline_linear_sccs = true)
end

@testset "`system_subset(::SystemStructure)` subsets `.state_priorities`" begin
    @variables x(t) y(t) [state_priority = 2] z(t) [state_priority = 5]
    @named sys = System([D(x) ~ x, D(y) ~ y, D(z) ~ z], t)
    ts = TearingState(sys)

    # Confirm priorities are set as expected in the full structure
    x_idx = findfirst(isequal(x), ts.fullvars)::Int
    y_idx = findfirst(isequal(y), ts.fullvars)::Int
    z_idx = findfirst(isequal(z), ts.fullvars)::Int
    @test ts.structure.state_priorities[x_idx] == 0
    @test ts.structure.state_priorities[y_idx] == 2
    @test ts.structure.state_priorities[z_idx] == 5

    # Subset to only y and z
    ieqs = [𝑑neighbors(ts.structure.graph, y_idx); 𝑑neighbors(ts.structure.graph, z_idx)]
    ivars = [y_idx, z_idx, ts.structure.var_to_diff[y_idx], ts.structure.var_to_diff[z_idx]]
    sub = MTKTearing.system_subset(ts.structure, ieqs, ivars)
    @test sub.state_priorities == [2, 5, 2, 5]
end

@testset "`trivial_tearing!` does not eliminate variables with positive state priority" begin
    # y only appears in `y ~ 2x`, making it a candidate for trivial tearing
    @variables x(t) y(t)
    @named sys = System([D(x) ~ x, y ~ 2x], t)
    ts = TearingState(sys)
    StateSelection.trivial_tearing!(ts)
    # Without state_priority, y is trivially torn into additional_observed
    @test findfirst(isequal(y), ts.fullvars) === nothing
    @test any(eq -> isequal(eq.lhs, y), ts.additional_observed)

    # With positive state_priority, y should not be trivially torn
    @variables x(t) y(t) [state_priority = 1]
    @named sys = System([D(x) ~ x, y ~ 2x], t)
    ts = TearingState(sys)
    StateSelection.trivial_tearing!(ts)
    @test findfirst(isequal(y), ts.fullvars) !== nothing
    @test !any(eq -> isequal(eq.lhs, y), ts.additional_observed)
end

@testset "`rm_eqs_vars!` does not require calling `complete`" begin
    @variables x(t) y(t)
    @named sys = System([D(x) ~ 2x + 1, D(y) ~ 2y + 1], t)
    ts = TearingState(sys)
    xidx = findfirst(isequal(x), ts.fullvars)::Int
    dxidx = ts.structure.var_to_diff[xidx]::Int
    eqidx = only(𝑑neighbors(ts.structure.graph, dxidx))::Int
    StateSelection.rm_eqs_vars!(ts, [eqidx], [xidx, dxidx])
    @test length(equations(ts)) == 1
    @test length(ts.fullvars) == 2
end

@testset "Unknowns in underdetermined systems aren't counted twice" begin
    @variables x[1:3]
    @mtkcompile sys = System([x[1] ~ 2x[2]+3x[3], x[2]^3 + x[3]^3 - 9 ~ 0], [x[1], x[2], x[3]], []) fully_determined=false
    # Without the fix in https://github.com/JuliaComputing/StateSelection.jl/pull/80
    # `unknowns` prior to running `tearing_hacks` will contain `x[3]` twice, so
    # the observed equation `x ~ [x[1], x[2], x[3]]` won't be added.
    @test isequal(observables(sys)[2], x)
end

const InferredDiscrete = MTKTearing.InferredClock.InferredDiscrete

struct Op1 <: Symbolics.Operator end
Op1(x, y) = Op1()(unwrap(x), unwrap(y))
(o::Op1)(x, y) = Symbolics.STerm(o, [x, y]; type = SU.symtype(x), shape = SU.shape(x))
SU.promote_symtype(::Op1, T::SU.TypeT, T2::SU.TypeT) = T
SU.promote_shape(::Op1, @nospecialize(sh::SU.ShapeT), @nospecialize(sh2::SU.ShapeT)) = sh
MTKTearing.input_timedomain(::Op1, _) = MTKTearing.InputTimeDomainElT[InferredDiscrete(1), InferredDiscrete(2)]
MTKTearing.output_timedomain(::Op1, _) = InferredDiscrete(2)
MTKTearing.is_transparent_operator(::Op1) = true
MTKTearing.is_timevarying_operator(::Op1) = true

struct Op2 <: Symbolics.Operator end
Op2(x, y) = Op2()(unwrap(x), unwrap(y))
(o::Op2)(x, y) = Symbolics.STerm(o, [x, y]; type = SU.symtype(x), shape = SU.shape(x))
SU.promote_symtype(::Op2, T::SU.TypeT, T2::SU.TypeT) = T
SU.promote_shape(::Op2, @nospecialize(sh::SU.ShapeT), @nospecialize(sh2::SU.ShapeT)) = sh
MTKTearing.input_timedomain(::Op2, _) = MTKTearing.InputTimeDomainElT[InferredDiscrete(1), InferredDiscrete(1)]
MTKTearing.output_timedomain(::Op2, _) = InferredDiscrete(2)
MTKTearing.is_transparent_operator(::Op2) = true
MTKTearing.is_timevarying_operator(::Op2) = true

struct Op3 <: Symbolics.Operator end
Op3(x) = Op3()(unwrap(x))
(o::Op3)(x::Symbolics.SymbolicT) = Symbolics.STerm(o, [x]; type = SU.symtype(x), shape = SU.shape(x))
SU.promote_symtype(::Op3, T::SU.TypeT) = T
SU.promote_shape(::Op3, @nospecialize(sh::SU.ShapeT)) = sh
MTKTearing.input_timedomain(::Op3, _) = MTKTearing.InputTimeDomainElT[InferredDiscrete(1)]
MTKTearing.output_timedomain(::Op3, _) = InferredDiscrete(1)
MTKTearing.is_transparent_operator(::Op3) = true
MTKTearing.is_timevarying_operator(::Op3) = true

@testset "Clock inference handles nested clock operators correctly" begin
    @variables x(t) y(t) z(t) w(t)
    clk1 = Clock(0.1)
    clk2 = Clock(0.2)
    k1 = ShiftIndex(clk1)
    k2 = ShiftIndex(clk2)

    # From `Op1`, we should infer that `clock_of(z) == clock_of(y)`
    # From `Op2`, we should infer that `clock_of(w) == clock_of(Op3(x))`
    # from `Op3`, we should infer that `clock_of(x) == clock_of(Op3(x))`
    # The `+ x` in `Op1` is just so that `Op2(..)` has a defined clock
    eqs = [
        z(k1) ~ Op1(Op2(Op3(x), w) + x, 3sin(y))
        x ~ x(k2-1) + 1
    ]
    @named sys = System(eqs, t, [x, y, z, w], [])
    ts = TearingState(sys)
    @test issetequal(ts.fullvars, [x, x(k2-1), y, z, w, Op3(x), Op2(Op3(x), w), Op1(Op2(Op3(x), w) + x, 3sin(y))])
    ci = MTKTearing.ClockInference(ts)
    MTKTearing.infer_clocks!(ci)
    idx = findfirst(isequal(w), ts.fullvars)
    @test ci.var_domain[idx] == clk2
    idx = findfirst(isequal(Op3(x)), ts.fullvars)
    @test ci.var_domain[idx] == clk2
    idx = findfirst(isequal(Op2(Op3(x), w)), ts.fullvars)
    @test ci.var_domain[idx] == clk2
    idx = findfirst(isequal(Op1(Op2(Op3(x), w) + x, 3sin(y))), ts.fullvars)
    @test ci.var_domain[idx] == clk1

    @test ci.expression_clocks[x] == clk2
    @test ci.expression_clocks[Op3(x)] == clk2
    @test ci.expression_clocks[w] == clk2
    @test ci.expression_clocks[Op2(Op3(x), w) + x] == clk2
    @test ci.expression_clocks[3sin(y)] == clk1

    # Check that this errors if `+ x` is not present.
    eqs = [
        z(k1) ~ Op1(Op2(Op3(x), w), 3sin(y))
        x ~ x(k2-1) + 1
    ]
    @named sys = System(eqs, t, [x, y, z, w], [])
    ts = TearingState(sys)
    @test issetequal(ts.fullvars, [x, x(k2-1), y, z, w, Op3(x), Op2(Op3(x), w), Op1(Op2(Op3(x), w), 3sin(y))])
    ci = MTKTearing.ClockInference(ts)
    @test_throws MTKTearing.ExpectedDiscreteClockPartitionError MTKTearing.infer_clocks!(ci)
end

@data ClockVertex begin
    # A variable identified by its index in `fullvars`
    Variable(Int)
    # An equation identified by its index in `equations(state)`
    Equation(Int)
    # An initialization equation identified by its index in `initialization_equations(state.sys)`
    InitEquation(Int)
    # A concrete, known clock
    Clock(SciMLBase.AbstractClock)
    # An unnamed, unnknown clock identified by some UUID stored in `ShiftIndex`
    InferredClock(UUID)
    # An arbitrary expression for which we want to preserve clocking information
    Expression(SymbolicT)
    # Compatibility for ModelingToolkit's `DiscreteSystem` semantics.
    IntegerSequence
end

Moshi.Derive.@derive ClockVertex[Show]

struct ClockInference{S <: StateSelection.TransformationState}
    """Tearing state."""
    ts::S
    """The time domain (discrete clock, continuous) of each equation."""
    eq_domain::Vector{TimeDomain}
    """The time domain (discrete clock, continuous) of each initialization equation."""
    init_eq_domain::Vector{TimeDomain}
    """The output time domain (discrete clock, continuous) of each variable."""
    var_domain::Vector{TimeDomain}
    inference_graph::HyperGraph{ClockVertex.Type}
    """The set of variables with concrete domains."""
    inferred::BitSet
    """A mapping from every argument of every clock operator to the clock it is on. More \
    generally extensible to any expression for which it is deemed necessary to preserve \
    clock information."""
    expression_clocks::Dict{SymbolicT, TimeDomain}
end

function ClockInference(ts::StateSelection.TransformationState)
    structure = ts.structure
    graph = structure.graph
    fullvars = StateSelection.get_fullvars(ts)
    sys = get_sys(ts)
    eq_domain = TimeDomain[SciMLBase.ContinuousClock() for _ in 1:nsrcs(graph)]
    init_eq_domain = TimeDomain[SciMLBase.ContinuousClock()
                                for _ in 1:length(MTKBase.initialization_equations(sys))]
    var_domain = TimeDomain[SciMLBase.ContinuousClock() for _ in 1:ndsts(graph)]
    inferred = BitSet()
    for (i, v) in enumerate(fullvars)
        d = get_time_domain(v)
        if is_concrete_time_domain(d)
            push!(inferred, i)
            var_domain[i] = d
        end
    end
    inference_graph = HyperGraph{ClockVertex.Type}()
    for i in 1:nsrcs(graph)
        add_vertex!(inference_graph, ClockVertex.Equation(i))
    end
    for i in eachindex(MTKBase.initialization_equations(ts.sys))
        add_vertex!(inference_graph, ClockVertex.InitEquation(i))
    end
    for i in 1:ndsts(graph)
        varvert = ClockVertex.Variable(i)
        add_vertex!(inference_graph, varvert)
        d = get_time_domain(fullvars[i])
        if !is_concrete_time_domain(d)
            if d isa InferredTimeDomain
                @match d begin
                    InferredClock.Inferred(id) => begin
                        dvert = ClockVertex.InferredClock(id)
                        add_vertex!(inference_graph, dvert)
                        add_edge!(inference_graph, (varvert, dvert))
                    end
                    _ => nothing
                end
            elseif d isa MTKBase.IntegerSequence
                dvert = ClockVertex.IntegerSequence()
                add_vertex!(inference_graph, dvert)
                add_edge!(inference_graph, (varvert, dvert))
            end
            continue
        end
        dvert = ClockVertex.Clock(d)
        add_vertex!(inference_graph, dvert)
        add_edge!(inference_graph, (varvert, dvert))
    end
    ClockInference{typeof(ts)}(ts, eq_domain, init_eq_domain, var_domain, inference_graph,
                               inferred, Dict{SymbolicT, TimeDomain}())
end

struct NotInferredTimeDomain end

struct InferEquationClosure
    varsbuf::OrderedSet{SymbolicT}
    # variables in each argument to an operator
    arg_varsbuf::OrderedSet{SymbolicT}
    # hyperedge for each equation
    hyperedge::Set{ClockVertex.Type}
    # hyperedge for each argument to an operator
    arg_hyperedge::Set{ClockVertex.Type}
    # mapping from `i` in `InferredDiscrete(i)` to the vertices in that inferred partition
    relative_hyperedges::Dict{Int, Set{ClockVertex.Type}}
    # vertices that must be discrete
    must_be_discrete::Set{ClockVertex.Type}
    var_to_idx::Dict{SymbolicT, Int}
    inference_graph::HyperGraph{ClockVertex.Type}
end

function InferEquationClosure(var_to_idx, inference_graph)
    InferEquationClosure(OrderedSet{SymbolicT}(), OrderedSet{SymbolicT}(), Set{ClockVertex.Type}(),
                         Set{ClockVertex.Type}(), Dict{Int, Set{ClockVertex.Type}}(),
                         Set{ClockVertex.Type}(), var_to_idx, inference_graph)
end

struct InferVariableClosure
    # The hyperedge that this variable exists in. Could be the hyperedge for an equation,
    # or one for the argument of a clock operator. The parent is responsible for
    # adding this hyperedge to the inference graph.
    parent_hyperedge::Set{ClockVertex.Type}
    # The list of variables to be explored in the parent. This allows
    # the variable to queue up additional variables to be searched
    # in the same context.
    vars_in_parent::OrderedSet{SymbolicT}
    # Mapping from `i` in `InferredDiscrete(i)` to the vertices in that inferred partition.
    relative_hyperedges::Dict{Int, Set{ClockVertex.Type}}
    # Variables in each argument to an operator.
    arg_varsbuf::OrderedSet{SymbolicT}
    # Hyperedge for each argument to an operator. This closure is responsible for
    # adding this hyperedge to the inference graph.
    arg_hyperedge::Set{ClockVertex.Type}
    var_to_idx::Dict{SymbolicT, Int}
    must_be_discrete::Set{ClockVertex.Type}
    inference_graph::HyperGraph{ClockVertex.Type}
end

# When searching a variable/operator application present directly in an equation
function InferVariableClosure(iec::InferEquationClosure)
    return InferVariableClosure(
        # This exists in the equation's hyperedge.
        iec.hyperedge,
        # Use the equation's queue for variables to explore.
        iec.varsbuf,
        # The next three are basically just preallocated buffers. Theoretically,
        # these could be omitted from both structs. However, it's very common to
        # have at least one clock operator in an expression, and unlikely to nest.
        # So this allows saving unnecessary allocations in each call to the
        # `InferVariableClosure`. It also allows the
        # `InferVariableClosure(::InferVariableClosure)` constructor to be simpler.
        iec.relative_hyperedges,
        iec.arg_varsbuf,
        iec.arg_hyperedge,
        # Shared information propagated across the hierarchy.
        iec.var_to_idx,
        iec.must_be_discrete,
        iec.inference_graph,
    )
end

# When searching a variable/operator application present in the argument of
# a clock operator. The returned `InferVariableClosure` will be called recursively
# from the `ivc` passed in.
function InferVariableClosure(ivc::InferVariableClosure)
    return InferVariableClosure(
        # This exists in the clock operator argument's hyperedge.
        ivc.arg_hyperedge,
        # Use the operator argument's queue.
        ivc.arg_varsbuf,
        # Cannot reuse buffers, allocate new ones.
        Dict{Int, Set{ClockVertex.Type}}(),
        OrderedSet{SymbolicT}(),
        Set{ClockVertex.Type}(),
        # Same shared information.
        ivc.var_to_idx,
        ivc.must_be_discrete,
        ivc.inference_graph,
    )
end

function (ivc::InferVariableClosure)(var::SymbolicT)
    # NOTE: Never add `hyperedge` to the graph. The parent is responsible for doing so.
    (; var_to_idx, parent_hyperedge, vars_in_parent, relative_hyperedges) = ivc
    (; arg_varsbuf, arg_hyperedge, must_be_discrete, inference_graph) = ivc
    hyperedge = parent_hyperedge

    idx = get(var_to_idx, var, nothing)
    # if this is just a single variable, add it to the hyperedge
    if idx isa Int
        push!(hyperedge, ClockVertex.Variable(idx))
        d = get_time_domain(var)
        if is_concrete_time_domain(d)
            push!(hyperedge, ClockVertex.Clock(d))
        elseif d isa InferredTimeDomain
            @match d begin
                InferredClock.Inferred(id) => push!(hyperedge, ClockVertex.InferredClock(id))
                _ => nothing
            end
        elseif d isa MTKBase.IntegerSequence
            push!(hyperedge, ClockVertex.IntegerSequence())
        end

        # we don't immediately `return` here because this variable might be a
        # `Sample` or similar and we want the clock information from it if it is.
    end

    # Leverage concrete clock information about this variable/operator application
    d = get_time_domain(var)
    if d === nothing
        arrv, isarr = MTKBase.split_indexed_var(var)
        d = get_time_domain(arrv)
    end
    if is_concrete_time_domain(d)::Bool
        push!(hyperedge, ClockVertex.Clock(d))
    elseif d isa InferredTimeDomain
        @match d begin
            InferredClock.Inferred(id) => push!(hyperedge, ClockVertex.InferredClock(id))
            _ => nothing
        end
    elseif d isa MTKBase.IntegerSequence
        push!(hyperedge, ClockVertex.IntegerSequence())
    end

    @match var begin
        # `Shift` sets the clock metadata of its input, so use that
        BSImpl.Term(; f, args) && if f isa Shift end => begin
            d = get_time_domain(args[1])
            if is_concrete_time_domain(d)::Bool
                push!(hyperedge, ClockVertex.Clock(d))
            elseif d isa InferredTimeDomain
                @match d begin
                    InferredClock.Inferred(id) => push!(hyperedge, ClockVertex.InferredClock(id))
                    _ => nothing
                end
            elseif d isa MTKBase.IntegerSequence
                push!(hyperedge, ClockVertex.IntegerSequence())
            end
        end
        _ => nothing
    end

    # now we only care about synchronous operators
    op, args = @match var begin
        BSImpl.Term(; f, args) && if is_timevarying_operator(f)::Bool end => (f, args)
        # If we have a symbolic array variable, process each of its elements
        if SU.is_array_shape(SU.shape(var)) end => begin
            for i in SU.stable_eachindex(var)
                push!(vars_in_parent, var[i])
            end
            return
        end
        _ => return
    end

    # arguments and corresponding time domains
    tdomains = input_timedomain(op, args)::Vector{InputTimeDomainElT}
    nargs = length(args)
    ndoms = length(tdomains)
    if nargs != ndoms
        throw(ArgumentError("""
                            Operator $op applied to $nargs arguments $args but only returns $ndoms \
                            domains $tdomains from `input_timedomain`.
                            """))
    end

    nested_ivc = InferVariableClosure(ivc)
    # each relative clock mapping is only valid per operator application
    empty!(relative_hyperedges)
    for (arg, domain) in zip(args, tdomains)
        empty!(arg_varsbuf)
        empty!(arg_hyperedge)
        # get variables in argument
        SU.search_variables!(arg_varsbuf, arg)
        # get hyperedge for involved variables
        for v in arg_varsbuf
            nested_ivc(v)
        end

        if !SU.isconst(arg)
            push!(arg_hyperedge, ClockVertex.Expression(arg))
        end
        # NOTE: Ensure all branches here add `arg_hyperedge` to the inference graph. It
        # is the parent hyperedge for `nested_ivc`, so this closure is responsible for
        # adding it to the graph.
        @match domain begin
            # If the time domain for this argument is a clock, then all variables in this edge have that clock.
            x::SciMLBase.AbstractClock => begin
                # add the clock to the edge
                push!(arg_hyperedge, ClockVertex.Clock(x))
                # add the edge to the graph
                add_edge!(inference_graph, arg_hyperedge)
            end
            x::MTKBase.IntegerSequence => begin
                push!(arg_hyperedge, ClockVertex.IntegerSequence())
                add_edge!(inference_graph, arg_hyperedge)
            end
            # We only know that this time domain is inferred. Treat it as a unique domain, all we know is that the
            # involved variables have the same clock.
            InferredClock.Inferred() => add_edge!(inference_graph, arg_hyperedge)
            # All `InferredDiscrete` with the same `i` have the same clock (including output domain) so we don't
            # add the edge, and instead add this to the `relative_hyperedges` mapping.
            InferredClock.InferredDiscrete(i) => begin
                relative_edge = get!(Set{ClockVertex.Type}, relative_hyperedges, i)
                union!(relative_edge, arg_hyperedge)
                # Ensure that this clock partition will be discrete.
                union!(must_be_discrete, arg_hyperedge)
                add_edge!(inference_graph, arg_hyperedge)
            end
        end
    end

    # Handle the output timedomain of this clock operator application.
    outdomain = output_timedomain(op, args)
    if outdomain isa SciMLBase.AbstractClock
        # If it is a clock we know, simply add it to the parent edge.
        push!(hyperedge, ClockVertex.Clock(outdomain))
    elseif outdomain isa InferredTimeDomain
        @match outdomain begin
            InferredClock.Inferred() => nothing
            InferredClock.InferredDiscrete(i) => begin
                # If we've encountered this relative inferreddiscrete index before,
                # we know that that relative hyperedge is the output. So include it
                # in the parent hyperedge.
                buffer = get(relative_hyperedges, i, nothing)
                if buffer !== nothing
                    union!(hyperedge, buffer)
                    delete!(relative_hyperedges, i)
                end
                # Everything here must be discrete.
                union!(must_be_discrete, hyperedge)
            end
        end
    else
        error("Unreachable reached!")
    end

    for (_, relative_edge) in relative_hyperedges
        add_edge!(inference_graph, relative_edge)
    end
end

function (iec::InferEquationClosure)(ieq::Int, eq::Equation, is_initialization_equation::Bool)
    (; varsbuf, hyperedge, inference_graph) = iec
    empty!(varsbuf)
    empty!(hyperedge)
    # get variables in equation
    SU.search_variables!(varsbuf, eq)
    # add the equation to the hyperedge
    eq_node = if is_initialization_equation
        ClockVertex.InitEquation(ieq)
    else
        ClockVertex.Equation(ieq)
    end
    push!(hyperedge, eq_node)
    ivc = InferVariableClosure(iec)
    for var in varsbuf
        ivc(var)
    end

    add_edge!(inference_graph, hyperedge)
end

"""
Update the equation-to-time domain mapping by inferring the time domain from the variables.
"""
function infer_clocks!(ci::ClockInference)
    (; ts, eq_domain, init_eq_domain, var_domain, inferred, inference_graph) = ci
    sys = get_sys(ts)
    fullvars = StateSelection.get_fullvars(ts)

    var_to_idx = Dict{SymbolicT, Int}()
    sizehint!(var_to_idx, length(fullvars))
    for (i, v) in enumerate(fullvars)
        var_to_idx[v] = i
    end

    # all shifted variables have the same clock as the unshifted variant
    for (i, v) in enumerate(fullvars)
        @match v begin
            BSImpl.Term(; f, args) && if f isa MTKBase.Shift end => begin
                unshifted = args[1]
                add_edge!(inference_graph, (
                    ClockVertex.Variable(i), ClockVertex.Variable(var_to_idx[unshifted])))
                td = get_time_domain(unshifted)
                if td isa TimeDomain
                    add_edge!(inference_graph, (ClockVertex.Variable(i), ClockVertex.Clock(td)))
                end
            end
            _ => nothing
        end
    end
    infer_equation = InferEquationClosure(var_to_idx, inference_graph)

    for (ieq, eq) in enumerate(MTKBase.equations(sys))
        infer_equation(ieq, eq, false)
    end
    for (ieq, eq) in enumerate(MTKBase.initialization_equations(sys))
        infer_equation(ieq, eq, true)
    end

    (; must_be_discrete) = infer_equation
    clock_partitions = Graphs.connected_components(inference_graph)
    for partition in clock_partitions
        clockidxs = findall(Base.Fix2(Moshi.Data.isa_variant, ClockVertex.Clock), partition)
        has_integer_sequence = any(
            Base.Fix2(Moshi.Data.isa_variant, ClockVertex.IntegerSequence), partition
        )

        if isempty(clockidxs)
            has_integer_sequence && continue
            if any(in(must_be_discrete), partition)
                throw(ExpectedDiscreteClockPartitionError(ts, partition, true))
            end
            push!(partition, ClockVertex.Clock(SciMLBase.ContinuousClock()))
            push!(clockidxs, length(partition))
        end
        if length(clockidxs) > 1
            vidxs = Int[vert.:1
                        for vert in partition
                        if Moshi.Data.isa_variant(vert, ClockVertex.Variable)]
            clks = [vert.:1 for vert in view(partition, clockidxs)]
            throw(ArgumentError("""
            Found clock partition with multiple associated clocks. Involved variables: \
            $(fullvars[vidxs]). Involved clocks: $(clks).
            """))
        end

        clock = Moshi.Match.@match partition[only(clockidxs)] begin
            ClockVertex.Clock(clk) => clk
        end
        if clock == SciMLBase.ContinuousClock() && any(in(must_be_discrete), partition)
            throw(ExpectedDiscreteClockPartitionError(ts, partition, false))
        end
        for vert in partition
            Moshi.Match.@match vert begin
                ClockVertex.Variable(i) => (var_domain[i] = clock)
                ClockVertex.Equation(i) => (eq_domain[i] = clock)
                ClockVertex.InitEquation(i) => (init_eq_domain[i] = clock)
                ClockVertex.Clock(_) => nothing
                ClockVertex.InferredClock(_) => nothing
                ClockVertex.IntegerSequence() => nothing
                ClockVertex.Expression(expr) => (ci.expression_clocks[expr] = clock)
            end
        end
    end

    ci = postprocess_clock_inference(ci, ts)
    return ci
end

struct ExpectedDiscreteClockPartitionError <: Exception
    state::TearingState
    partition::Vector{ClockVertex.Type}
    has_no_clock::Bool
end

function Base.showerror(io::IO, err::ExpectedDiscreteClockPartitionError)
    if err.has_no_clock
        println(io, """
        Found a clock partition that must be discrete (due to the presence of an \
        `InferredDiscrete`) but does not have any associated clock (and would otherwise \
        then default to being on the continuous clock). This likely means that the \
        partition was not assigned a valid discrete clock and the model is incorrect.
        """)
    else
        println(io, """
        Found a clock partition that must be discrete (due to the presence of an \
        `InferredDiscrete`) but is associated with a continuous clock. This is likely \
        a modeling error.
        """)
    end

    vars = filter(Base.Fix2(Moshi.Data.isa_variant, ClockVertex.Variable), err.partition)
    println(io, "Variables in the partition:")
    for var in vars
        println(io, "  ", err.state.fullvars[var.:1])
    end
    println(io)

    eqs = filter(Base.Fix2(Moshi.Data.isa_variant, ClockVertex.Equation), err.partition)
    println(io, "Equations in the partition:")
    for eq in eqs
        println(io, "  ", equations(err.state)[eq.:1])
    end
    println(io)

    ieqs = filter(Base.Fix2(Moshi.Data.isa_variant, ClockVertex.InitEquation), err.partition)
    println(io, "Initialization equations in the partition:")
    for ieq in ieqs
        println(io, "  ", initialization_equations(err.state.sys)[ieq.:1])
    end
end

function resize_or_push!(v, val, idx)
    n = length(v)
    if idx > n
        for _ in (n + 1):idx
            push!(v, Int[])
        end
        resize!(v, idx)
    end
    push!(v[idx], val)
end

function is_time_domain_conversion(v::SymbolicT)
    @match v begin
        BSImpl.Term(; f, args) && if f isa SU.Operator end => begin
            itd = input_timedomain(f, args)::Vector{InputTimeDomainElT}
            allequal(itd) || return true
            isempty(itd) && return true
            otd = output_timedomain(f, args)::InputTimeDomainElT
            (itd[1] == otd)::Bool || return true
            return false
        end
        _ => return false
    end
end

"""
For multi-clock systems, create a separate system for each clock in the system, along with associated equations. Return the updated tearing state, and the sets of clocked variables associated with each time domain.
"""
function split_system(ci::ClockInference{S}) where {S}
    (; ts, eq_domain, init_eq_domain, var_domain, inferred) = ci
    fullvars = StateSelection.get_fullvars(ts)
    sys = get_sys(ts)
    graph = ts.structure.graph
    continuous_id = Ref(0)
    clock_to_id = Dict{TimeDomain, Int}()
    id_to_clock = TimeDomain[]
    eq_to_cid = Vector{Int}(undef, nsrcs(graph))
    cid_to_eq = Vector{Int}[]
    init_eq_to_cid = Vector{Int}(undef, length(MTKBase.initialization_equations(sys)))
    cid_to_init_eq = Vector{Int}[]
    var_to_cid = Vector{Int}(undef, ndsts(graph))
    cid_to_var = Vector{Int}[]
    # cid_counter = number of clocks
    cid_counter = Ref(0)

    # populates clock_to_id and id_to_clock
    # checks if there is a continuous_id (for some reason? clock to id does this too)
    for (i, d) in enumerate(eq_domain)
        # We don't use `get!` here because that desperately wants to box things
        cid = get(clock_to_id, d, 0)
        if iszero(cid)
            cid = (cid_counter[] += 1)
            push!(id_to_clock, d)
            if d === SciMLBase.ContinuousClock()
                continuous_id[] = cid
            end
            clock_to_id[d] = cid
        end
        eq_to_cid[i] = cid
        resize_or_push!(cid_to_eq, i, cid)
    end
    # NOTE: This assumes that there is at least one equation for each clock
    for _ in 1:length(cid_to_eq)
        push!(cid_to_init_eq, Int[])
    end
    for (i, d) in enumerate(init_eq_domain)
        cid = clock_to_id[d]
        init_eq_to_cid[i] = cid
        push!(cid_to_init_eq[cid], i)
    end
    continuous_id = continuous_id[]
    # for each clock partition what are the input (indexes/vars)
    input_idxs = map(_ -> Int[], 1:cid_counter[])
    inputs = map(_ -> SymbolicT[], 1:cid_counter[])
    # var_domain corresponds to fullvars/all variables in the system
    nvv = length(var_domain)
    # put variables into the right clock partition
    # keep track of inputs to each partition
    for i in 1:nvv
        d = var_domain[i]
        cid = get(clock_to_id, d, 0)
        @assert cid!==0 "Internal error! Variable $(fullvars[i]) doesn't have a inferred time domain."
        var_to_cid[i] = cid
        v = fullvars[i]
        if is_time_domain_conversion(v)
            push!(input_idxs[cid], i)
            push!(inputs[cid], fullvars[i])
        end
        resize_or_push!(cid_to_var, i, cid)
    end

    # breaks the system up into a continuous and 0 or more discrete systems
    tss = similar(cid_to_eq, S)
    for (id, (ieqs, iieqs, ivars)) in enumerate(zip(cid_to_eq, cid_to_init_eq, cid_to_var))
        ts_i = system_subset(ts, ieqs, iieqs, ivars)
        if id != continuous_id
            ts_i = mark_discrete(ts_i)
        end
        tss[id] = ts_i
    end
    # put the continuous system at the back
    if continuous_id != 0
        tss[continuous_id], tss[end] = tss[end], tss[continuous_id]
        inputs[continuous_id], inputs[end] = inputs[end], inputs[continuous_id]
        id_to_clock[continuous_id],
        id_to_clock[end] = id_to_clock[end],
        id_to_clock[continuous_id]
        continuous_id = lastindex(tss)
    end
    return tss, inputs, continuous_id, id_to_clock
end

function StateSelection.var_derivative!(ts::TearingState, v::Int)
    s = ts.structure
    var_diff = StateSelection.var_derivative_graph!(s, v)
    sys = ts.sys
    D = Differential(MTKBase.get_iv(sys))
    push!(ts.fullvars, D(ts.fullvars[v]))
    push!(ts.structure.state_priorities, ts.structure.state_priorities[v])
    push!(ts.structure.var_types, ts.structure.var_types[v])
    push!(ts.always_present, ts.always_present[v])
    return var_diff
end

function StateSelection.eq_derivative!(ts::TearingState, ieq::Int; kwargs...)
    s = ts.structure

    eq_diff = StateSelection.eq_derivative_graph!(s, ieq)

    sys = ts.sys
    eqs = equations(ts)
    eq = equations(ts)[ieq]
    eq = Symbolics.COMMON_ZERO ~ substitute(
        Symbolics.derivative(
            eq.rhs - eq.lhs, MTKBase.get_iv(sys); throw_no_derivative = true), ts.param_derivative_map)

    vs = Set{SymbolicT}()
    SU.search_variables!(vs, eq.rhs)
    for v in vs
        v in ts.no_deriv_params || continue
        _original_eq = equations(ts)[ieq]
        error("""
        Encountered derivative of discrete variable `$(only(arguments(v)))` when \
        differentiating equation `$(_original_eq)`. This may indicate a model error or a \
        missing equation of the form `$v ~ ...` that defines this derivative.
        """)
    end

    push!(eqs, eq)
    # Analyze the new equation and update the graph/solvable_graph
    # First, copy the previous incidence and add the derivative terms.
    # That's a superset of all possible occurrences. find_solvables! will
    # remove those that doesn't actually occur.
    @assert length(equations(ts)) == eq_diff
    for var in 𝑠neighbors(s.graph, ieq)
        add_edge!(s.graph, eq_diff, var)
        add_edge!(s.graph, eq_diff, s.var_to_diff[var])
    end

    # `symbolically_rm_singular = false` because a lot of the removed
    # variables aren't actually symbolically present in the system. This
    # will thus cause a lot of unnecessary calls to `Symbolics.linear_expansion`.
    # We already ran `search_variables!`, so we can identify the ones that
    # really need to be removed here.
    to_rm = Int[]
    s.solvable_graph === nothing || StateSelection.find_eq_solvables!(
        ts, eq_diff, to_rm; may_be_zero = true, allow_symbolic = false,
        symbolically_rm_singular = false, kwargs...
    )

    for i in to_rm
        ts.fullvars[i] in vs || continue
        a, b, islin = Symbolics.linear_expansion(eqs[eq_diff].rhs, ts.fullvars[i])
        @assert islin && SU._iszero(a)
        eqs[eq_diff] = Symbolics.COMMON_ZERO ~ b
    end
    return eq_diff
end

function StateSelection.linear_subsys_adjmat!(state::TearingState; kwargs...)
    graph = state.structure.graph
    if state.structure.solvable_graph === nothing
        state.structure.solvable_graph = BipartiteGraph(nsrcs(graph), ndsts(graph))
    end
    linear_equations = Int[]
    eqs = equations(state.sys)
    eadj = Vector{Int}[]
    cadj = Vector{Int}[]
    coeffs = Int[]
    to_rm = Int[]
    fullvars_set = Set{SymbolicT}(state.fullvars)
    for v in state.fullvars
        @match v begin
            BSImpl.Term(; f, args) && if f === getindex end => push!(fullvars_set, args[1])
            _ => nothing
        end
    end
    for i in eachindex(eqs)
        all_int_vars, rhs = StateSelection.find_eq_solvables!(state, i, to_rm, coeffs; fullvars_set, kwargs...)

        # Check if all unknowns in the equation is both linear and homogeneous,
        # i.e. it is in the form of
        #
        #       ``∑ c_i * v_i = 0``,
        #
        # where ``c_i`` ∈ ℤ and ``v_i`` denotes unknowns.
        if all_int_vars && Symbolics._iszero(rhs)
            push!(linear_equations, i)
            push!(eadj, copy(𝑠neighbors(graph, i)))
            push!(cadj, copy(coeffs))
        end
    end

    mm = CLIL.SparseMatrixCLIL(nsrcs(graph),
        ndsts(graph),
        linear_equations, eadj, cadj)
    return mm
end

function maybe_zeros_descend(ex::SymbolicT)
    @match ex begin
        BSImpl.AddMul(; variant) => return variant === SU.AddMulVariant.MUL
        BSImpl.Term(; f) => return f === (^) || f === sin || f === adjoint || f === LinearAlgebra.dot || f === getindex || f === ifelse || f === max || f === min
        _ => return false
    end
end

"""
    $TYPEDEF

Functor used by `query_maybe_zeros`.

# Fields

$TYPEDFIELDS
"""
struct MaybeZeroQueryFn{Z}
    """
    `MTKBase.maybe_zeros(sys)`
    """
    maybe_zeros::Z
end

"""
    $METHODLIST

Check if `ex` contains any expressions in `qf.maybe_zeros` as factors, or in places
that could cause `ex` to be zero.
"""
function query_maybe_zeros(qf::MaybeZeroQueryFn, ex::SymbolicT)
    return SU.query(qf, ex; recurse = maybe_zeros_descend)
end
function query_maybe_zeros(qf::MaybeZeroQueryFn, ex::AbstractArray)
    return any(Base.Fix1(query_maybe_zeros, qf) ∘ unwrap, ex)
end

function (qf::MaybeZeroQueryFn)(ex::SymbolicT)
    (; maybe_zeros) = qf
    MTKBase.split_indexed_var(ex)[1] in maybe_zeros && return true
    pred = in(maybe_zeros) ∘ first ∘ MTKBase.split_indexed_var
    @match ex begin
        BSImpl.Const(; val) => SU._iszero(val)
        BSImpl.AddMul(; dict, variant) && if variant === SU.AddMulVariant.MUL end => begin
            return any(pred, keys(dict))
        end
        BSImpl.AddMul(; coeff, dict, variant) && if variant === SU.AddMulVariant.ADD end => begin
            return SU._iszero(coeff) && all(Base.Fix1(query_maybe_zeros, qf), keys(dict))
        end
        BSImpl.Term(; f, args) => begin
            if f === (^) || f === sin || f === adjoint || f === LinearAlgebra.dot || f === max || f === min
                return any(pred, args)
            elseif f === getindex
                return args[1] in maybe_zeros
            elseif f === ifelse
                return pred(args[2]) || pred(args[3])
            end
            return false
        end
        _ => return false
    end
end

"""
    $METHODLIST

Check if `x` is fully constant (not a symbolic expression or array thereof).
"""
query_all_const(x::SymbolicT) = SU.isconst(x)
query_all_const(x::AbstractArray) = all(SU.isconst ∘ unwrap, x)

"""
    $METHODLIST

Check if `denom` contains any vars present in `state.fullvars`.
"""
function query_any_vars(state::TearingState, denom, ::Nothing)
    fullvars_set = Set{SymbolicT}(state.fullvars)
    for v in state.fullvars
        push!(fullvars_set, MTKBase.split_indexed_var(v)[1])
    end
    query_any_vars(state, denom, fullvars_set)
end
function query_any_vars(state::TearingState, denom::Union{SymbolicT, AbstractArray}, fullvars_set::Set{SymbolicT})
    __allow_sym_par_cond = let fullvars_set = fullvars_set,
        is_atomic = MTKBase.OperatorIsAtomic{SU.Operator}()
        function allow_sym_par_cond(v)
            is_atomic(v) && v in fullvars_set || SU.shape(v) isa SU.Unknown
         end
    end
    if denom isa SymbolicT
        return SU.query(__allow_sym_par_cond, denom)
    else
        return any(Base.Fix1(SU.query, __allow_sym_par_cond) ∘ unwrap, denom)
    end
end

"""
    $TYPEDSIGNATURES

Check if dividing by `denom` is allowed, given the restrictions imposed by `allow_parameter`
and `allow_symbolic`. Also checks that expressions in `maybe_zeros(state.sys)` won't cause
`denom` to be zero. `denom` may be a symbolic or array thereof.
"""
function _check_allow_symbolic_parameter(
        state::TearingState, denom, allow_symbolic::Bool,
        allow_parameter::Bool; fullvars_set::Union{Set{SymbolicT}, Nothing} = nothing
    )
    if allow_symbolic
        return true
    end
    if !allow_symbolic && !allow_parameter
        return query_all_const(denom)
    end
    if !allow_symbolic
        maybe_zeros = MTKBase.maybe_zeros(state.sys)
        query_maybe_zeros(MaybeZeroQueryFn(maybe_zeros), denom) && return false

        query_any_vars(state, denom, fullvars_set) && return false
    end
    return true
end


const _SUPPORTS_NEED_REMAINDER = isdefined(Symbolics, :SUPPORTS_LINEAR_EXPANDER_NEED_REMAINDER)

function StateSelection.find_eq_solvables!(state::TearingState, ieq, to_rm = Int[], coeffs = nothing;
        # this used to be `false`, but I can't find a place where this is called
        # that doesn't want to remove false incidences, and it fixes several bugs.
        # So now this defaults to `true`.
        may_be_zero = true,
        allow_symbolic = false, allow_parameter = true,
        conservative = false,
        symbolically_rm_singular = true,
        fullvars_set::Union{Set{SymbolicT}, Nothing} = nothing,
        kwargs...)
    (; fullvars, sys) = state
    (; graph, solvable_graph) = state.structure

    eq = equations(state)[ieq]
    term = unwrap(eq.rhs - eq.lhs)
    all_int_vars = true
    coeffs === nothing || empty!(coeffs)
    empty!(to_rm)

    if fullvars_set === nothing
        fullvars_set = Set{SymbolicT}(fullvars)
        for v in fullvars
            @match v begin
                BSImpl.Term(; f, args) && if f === getindex end => push!(fullvars_set, args[1])
                _ => nothing
            end
        end
    end
    for j in 𝑠neighbors(graph, ieq)
        var = fullvars[j]
        MTKBase.isirreducible(var) && (all_int_vars = false; continue)
        # Once `all_int_vars` is false the equation can't enter the integer-linear
        # subsystem, so the remainder (needed only for peeling/homogeneity) is dead
        # weight — ask the expander to skip rebuilding it (when supported).
        lex = MTKBase.get_linear_expander_for!(sys, var, true)
        a, b, islinear = _SUPPORTS_NEED_REMAINDER ? lex(term; need_remainder = all_int_vars) : lex(term)
        islinear || (all_int_vars = false; continue)
        if !SU.isconst(a)
            all_int_vars = false
            if !_check_allow_symbolic_parameter(state, a, allow_symbolic, allow_parameter; fullvars_set)
                continue
            end
            add_edge!(solvable_graph, ieq, j)
            continue
        end
        if !(SU.symtype(a) <: Number)
            all_int_vars = false
            continue
        end
        # When the expression is linear with numeric `a`, then we can safely
        # only consider `b` for the following iterations.
        if _SUPPORTS_NEED_REMAINDER
            all_int_vars && (term = b)
        else
            term = b
        end
        a = manual_dispatch_is_small_int(unwrap_const(a))::Int
        if a == typemin(Int)
            all_int_vars = false
            conservative && continue
        elseif conservative && abs(a) > 1
            continue
        elseif coeffs !== nothing && (!iszero(a) || !may_be_zero)
            push!(coeffs, a)
        end

        if !iszero(a)
            add_edge!(solvable_graph, ieq, j)
            continue
        end

        if may_be_zero
            push!(to_rm, j)
        else
            @warn "Internal error: Variable $var was marked as being in $eq, but was actually zero"
        end
    end
    for j in to_rm
        rem_edge!(graph, ieq, j)
        symbolically_rm_singular || continue
        eq = equations(state)[ieq]
        a, b, islin = MTKBase.get_linear_expander_for!(sys, fullvars[j], true)(eq.rhs)
        SU._iszero(a) && islin || continue
        equations(state)[ieq] = eq.lhs ~ b
    end
    all_int_vars, term
end

"""
    $TYPEDSIGNATURES

If `x` is a small integer (fits in `Int8`) return `Int(x)`. Otherwise, return
`typemin(Int)`.
"""
function manual_dispatch_is_small_int(@nospecialize(x::Number))::Int
    if x isa Int
        return typemin(Int8) <= x <= typemax(Int8) ? x : typemin(Int)
    elseif x isa BigInt
        return typemin(Int8) <= x <= typemax(Int8) ? Int(x) : typemin(Int)
    elseif x isa Int32
        return typemin(Int8) <= x <= typemax(Int8) ? Int(x) : typemin(Int)
    elseif x isa Float64
        return isinteger(x) && typemin(Int8) <= x <= typemax(Int8) ? Int(x) : typemin(Int)
    elseif x isa Float32
        return isinteger(x) && typemin(Int8) <= x <= typemax(Int8) ? Int(x) : typemin(Int)
    elseif x isa BigFloat
        return isinteger(x) && typemin(Int8) <= x <= typemax(Int8) ? Int(x) : typemin(Int)
    elseif x isa Rational{Int}
        return isinteger(x) && typemin(Int8) <= x <= typemax(Int8) ? Int(x) : typemin(Int)
    elseif x isa Rational{Int32}
        return isinteger(x) && typemin(Int8) <= x <= typemax(Int8) ? Int(x) : typemin(Int)
    elseif x isa Rational{BigInt}
        return isinteger(x) && typemin(Int8) <= x <= typemax(Int8) ? Int(x) : typemin(Int)
    else
        return if isinteger(x)::Bool && (typemin(Int8) <= x <= typemax(Int8))::Bool
            Int(x)::Int
        else
            typemin(Int)
        end
    end
end

function StateSelection.rm_eqs_vars!(
        structure::SystemStructure, eqs_to_rm::Vector{Int}, vars_to_rm::Vector{Int};
        eqs_sorted_and_uniqued::Bool = false, vars_sorted_and_uniqued::Bool = false
    )
    old_to_new_eq, old_to_new_var = StateSelection.default_rm_eqs_vars!(
        structure, eqs_to_rm, vars_to_rm; eqs_sorted_and_uniqued, vars_sorted_and_uniqued
    )
    deleteat!(structure.state_priorities, vars_to_rm)
    deleteat!(structure.var_types, vars_to_rm)
    return old_to_new_eq, old_to_new_var
end

function StateSelection.rm_eqs_vars!(
        state::TearingState, eqs_to_rm::Vector{Int}, vars_to_rm::Vector{Int};
        eqs_sorted_and_uniqued::Bool = false, vars_sorted_and_uniqued::Bool = false
    )
    (; structure, sys) = state
    old_to_new_eq, old_to_new_var = StateSelection.rm_eqs_vars!(
        structure, eqs_to_rm, vars_to_rm; eqs_sorted_and_uniqued, vars_sorted_and_uniqued
    )
    deleteat!(state.fullvars, vars_to_rm)
    deleteat!(state.always_present, vars_to_rm)
    eqs = copy(MTKBase.get_eqs(state.sys))
    deleteat!(eqs, eqs_to_rm)
    deleteat!(state.original_eqs, eqs_to_rm)
    if !isempty(state.eqs_source)
        deleteat!(state.eqs_source, eqs_to_rm)
    end

    @set! sys.eqs = eqs
    state.sys = sys

    return old_to_new_eq, old_to_new_var
end

function StateSelection.is_unused_var(state::TearingState, var::Integer)
    return !state.always_present[var] && isempty(𝑑neighbors(state.structure.graph, var))
end

_nameof(s) = nameof(s)
_nameof(s::Union{Int, Symbol}) = s
abstract type StateMachineOperator end
Base.broadcastable(x::StateMachineOperator) = Ref(x)
Symbolics.hide_lhs(_::StateMachineOperator) = true
struct InitialState <: StateMachineOperator
    s::Any
end
Base.show(io::IO, s::InitialState) = print(io, "initial_state(", _nameof(s.s), ")")
initial_state(s) = Equation(InitialState(nothing), InitialState(s))

Base.@kwdef struct Transition{A, B, C} <: StateMachineOperator
    from::A = nothing
    to::B = nothing
    cond::C = nothing
    immediate::Bool = true
    reset::Bool = true
    synchronize::Bool = false
    priority::Int = 1
    function Transition(from, to, cond, immediate, reset, synchronize, priority)
        cond = unwrap(cond)
        new{typeof(from), typeof(to), typeof(cond)}(from, to, cond, immediate,
            reset, synchronize,
            priority)
    end
end
function Base.:(==)(transition1::Transition, transition2::Transition)
    transition1.from == transition2.from &&
        transition1.to == transition2.to &&
        isequal(transition1.cond, transition2.cond) &&
        transition1.immediate == transition2.immediate &&
        transition1.reset == transition2.reset &&
        transition1.synchronize == transition2.synchronize &&
        transition1.priority == transition2.priority
end

"""
    transition(from, to, cond; immediate::Bool = true, reset::Bool = true, synchronize::Bool = false, priority::Int = 1)

Create a transition from state `from` to state `to` that is enabled when transitioncondition `cond` evaluates to `true`.

# Arguments:
- `from`: The source state of the transition.
- `to`: The target state of the transition.
- `cond`: A transition condition that evaluates to a Bool, such as `ticksInState() >= 2`.
- `immediate`: If `true`, the transition will fire at the same tick as it becomes true, if `false`, the actions of the state are evaluated first, and the transition fires during the next tick.
- `reset`: If true, the destination state `to` is reset to its initial condition when the transition fires.
- `synchronize`: If true, the transition will only fire if all sub-state machines in the source state are in their final (terminal) state. A final state is one that has no outgoing transitions.
- `priority`: If a state has more than one outgoing transition, all outgoing transitions must have a unique priority. The transitions are evaluated in priority order, i.e., the transition with priority 1 is evaluated first.
"""
function transition(from, to, cond;
        immediate::Bool = true, reset::Bool = true, synchronize::Bool = false,
        priority::Int = 1)
    Equation(
        Transition(), Transition(; from, to, cond, immediate, reset,
            synchronize, priority))
end
function Base.show(io::IO, s::Transition)
    print(io, _nameof(s.from), " → ", _nameof(s.to), " if (", s.cond, ") [")
    print(io, "immediate: ", Int(s.immediate), ", ")
    print(io, "reset: ", Int(s.reset), ", ")
    print(io, "sync: ", Int(s.synchronize), ", ")
    print(io, "prio: ", s.priority, "]")
end

function activeState end
function entry end
function ticksInState end
function timeInState end

for (s, T) in [(:timeInState, :Real),
    (:ticksInState, :Integer),
    (:entry, :Bool),
    (:activeState, :Bool)]
    seed = hash(s)
    @eval begin
        $s(x) = wrap(term($s, x))
        SymbolicUtils.promote_symtype(::typeof($s), ::Type{S}) where {S} = $T
    end
    if s != :activeState
        @eval $s() = wrap(term($s))
    end
end

@doc """
    timeInState()
    timeInState(state)

Get the time (in seconds) spent in a state in a finite state machine.

When used to query the time spent in the enclosing state, the method without arguments is used, i.e.,
```julia
@mtkmodel FSM begin
    ...
    @equations begin
        var(k+1) ~ timeInState() >= 2 ? 0.0 : var(k)
    end
end
```

If used to query the residence time of another state, the state is passed as an argument.

This operator can be used in both equations and transition conditions.

See also [`ticksInState`](@ref) and [`entry`](@ref)
""" timeInState

@doc """
    ticksInState()
    ticksInState(state)

Get the number of ticks spent in a state in a finite state machine.

When used to query the number of ticks spent in the enclosing state, the method without arguments is used, i.e.,
```julia
@mtkmodel FSM begin
    ...
    @equations begin
        var(k+1) ~ ticksInState() >= 2 ? 0.0 : var(k)
    end
end
```

If used to query the number of ticks in another state, the state is passed as an argument.

This operator can be used in both equations and transition conditions.

See also [`timeInState`](@ref) and [`entry`](@ref)
""" ticksInState

@doc """
    entry()
    entry(state)

When used in a finite-state machine, this operator returns true at the first tick when the state is active, and false otherwise.

When used to query the entry of the enclosing state, the method without arguments is used, when used to query the entry of another state, the state is passed as an argument.

This can be used to perform a unique action when entering a state.
"""
entry

@doc """
    activeState(state)

When used in a finite state machine, this operator returns `true` if the queried state is active and false otherwise. 
""" activeState

function SU.search_variables!(vars, O::Transition; kwargs...)
    SU.search_variables!(vars, O.from; kwargs...)
    SU.search_variables!(vars, O.to; kwargs...)
    SU.search_variables!(vars, O.cond; kwargs...)
    return vars
end
function SU.search_variables!(vars, O::InitialState; kwargs...)
    SU.search_variables!(vars, O.s; kwargs...)
end
function SU.search_variables!(vars, O::StateMachineOperator; kwargs...)
    error("Unhandled state machine operator")
end

function MTKBase.namespace_expr(
        O::Transition, sys, n = nameof(sys); ivs = independent_variables(sys))
    return Transition(
        O.from === nothing ? O.from : renamespace(sys, O.from),
        O.to === nothing ? O.to : renamespace(sys, O.to),
        O.cond === nothing ? O.cond : namespace_expr(O.cond, sys),
        O.immediate, O.reset, O.synchronize, O.priority
    )
end

function MTKBase.namespace_expr(
        O::InitialState, sys, n = nameof(sys); ivs = independent_variables(sys))
    return InitialState(O.s === nothing ? O.s : renamespace(sys, O.s))
end

function MTKBase.namespace_expr(O::StateMachineOperator, sys, n = nameof(sys); kwargs...)
    error("Unhandled state machine operator")
end

using OffsetArrays: Origin

#=
function check_diff_graph(var_to_diff, fullvars)
    diff_to_var = invview(var_to_diff)
    for (iv, v) in enumerate(fullvars)
        ov, order = var_from_nested_derivative(v)
        graph_order = 0
        vv = iv
        while true
            vv = diff_to_var[vv]
            vv === nothing && break
            graph_order += 1
        end
        @assert graph_order==order "graph_order: $graph_order, order: $order for variable $v"
    end
end
=#

"""
Replace derivatives of non-selected unknown variables by dummy derivatives.

State selection may determine that some differential variables are
algebraic variables in disguise. The derivative of such variables are
called dummy derivatives.

`SelectedState` information is no longer needed after this function is called.
State selection is done. All non-differentiated variables are algebraic
variables, and all variables that appear differentiated are differential variables.
"""
function substitute_derivatives_algevars!(
        ts::TearingState, neweqs::Vector{Equation}, var_eq_matching::Matching, dummy_sub::Dict{SymbolicT, SymbolicT}, iv::Union{Nothing, SymbolicT}, D::Union{Nothing, Differential, Shift})
    (; fullvars, sys, structure) = ts
    (; solvable_graph, var_to_diff, eq_to_diff, graph) = structure
    diff_to_var = invview(var_to_diff)

    for var in 1:length(fullvars)
        dv = var_to_diff[var]
        dv === nothing && continue
        if var_eq_matching[var] !== SelectedState()
            dd = fullvars[dv]
            v_t = MTKBase.diff2term_with_unit(dd, iv)
            for eq in 𝑑neighbors(graph, dv)
                dummy_sub[dd] = v_t
                neweqs[eq] = substitute(neweqs[eq], dd => v_t)
            end
            fullvars[dv] = v_t
            # If we have:
            # x -> D(x) -> D(D(x))
            # We need to to transform it to:
            # x   x_t -> D(x_t)
            # update the structural information
            dx = dv
            x_t = v_t
            while (ddx = var_to_diff[dx]) !== nothing
                dx_t = D(x_t)
                for eq in 𝑑neighbors(graph, ddx)
                    neweqs[eq] = substitute(neweqs[eq], fullvars[ddx] => dx_t)
                end
                fullvars[ddx] = dx_t
                dx = ddx
                x_t = dx_t
            end
            diff_to_var[dv] = nothing
        end
    end
end

#=
There are three cases where we want to generate new variables to convert
the system into first order (semi-implicit) ODEs.

1. To first order:
Whenever higher order differentiated variable like `D(D(D(x)))` appears,
we introduce new variables `x_t`, `x_tt`, and `x_ttt` and new equations
```
D(x_tt) = x_ttt
D(x_t) = x_tt
D(x) = x_t
```
and replace `D(x)` to `x_t`, `D(D(x))` to `x_tt`, and `D(D(D(x)))` to
`x_ttt`.

2. To implicit to semi-implicit ODEs:
2.1: Unsolvable derivative:
If one derivative variable `D(x)` is unsolvable in all the equations it
appears in, then we introduce a new variable `x_t`, a new equation
```
D(x) ~ x_t
```
and replace all other `D(x)` to `x_t`.

2.2: Solvable derivative:
If one derivative variable `D(x)` is solvable in at least one of the
equations it appears in, then we introduce a new variable `x_t`. One of
the solvable equations must be in the form of `0 ~ L(D(x), u...)` and
there exists a function `l` such that `D(x) ~ l(u...)`. We should replace
it to
```
0 ~ x_t - l(u...)
D(x) ~ x_t
```
and replace all other `D(x)` to `x_t`.

Observe that we don't need to actually introduce a new variable `x_t`, as
the above equations can be lowered to
```
x_t := l(u...)
D(x) ~ x_t
```
where `:=` denotes assignment.

As a final note, in all the above cases where we need to introduce new
variables and equations, don't add them when they already exist.

###### DISCRETE SYSTEMS #######

Documenting the differences to structural simplification for discrete systems:

In discrete systems everything gets shifted forward a timestep by `shift_discrete_system`
in order to properly generate the difference equations.

In the system x(k) ~ x(k-1) + x(k-2), becomes Shift(t, 1)(x(t)) ~ x(t) + Shift(t, -1)(x(t))

The lowest-order term is Shift(t, k)(x(t)), instead of x(t). As such we actually want
dummy variables for the k-1 lowest order terms instead of the k-1 highest order terms.

Shift(t, -1)(x(t)) -> x\_{t-1}(t)

Since Shift(t, -1)(x) is not a derivative, it is directly substituted in `fullvars`.
No equation or variable is added for it.

For ODESystems D(D(D(x))) in equations is recursively substituted as D(x) ~ x_t, D(x_t) ~ x_tt, etc.
The analogue for discrete systems, Shift(t, 1)(Shift(t,1)(Shift(t,1)(Shift(t, -3)(x(t)))))
does not actually appear. So `total_sub` in generate_system_equations` is directly
initialized with all of the lowered variables `Shift(t, -3)(x) -> x_t-3(t)`, etc.
=#
"""
Generate new derivative variables for the system.

Effects on the system structure:
- fullvars: add the new derivative variables x_t
- neweqs: add the identity equations for the new variables, D(x) ~ x_t
- graph: update graph with the new equations and variables, and their connections
- solvable_graph: mark the new equation as solvable for `D(x)`
- var_eq_matching: match D(x) to the added identity equation `D(x) ~ x_t`
- full_var_eq_matching: match `x_t` to the equation that `D(x)` used to match to, and
  match `D(x)` to `D(x) ~ x_t`
- var_sccs: Replace `D(x)` in its SCC by `x_t`, and add `D(x)` in its own SCC. Return
  the new list of SCCs.
"""
function generate_derivative_variables!(
        ts::TearingState, neweqs, var_eq_matching, full_var_eq_matching,
        var_sccs, mm::Union{Nothing, CLIL.SparseMatrixCLIL}, iv::Union{SymbolicT, Nothing})
    (; fullvars, sys, structure) = ts
    (; solvable_graph, var_to_diff, eq_to_diff, graph) = structure
    eq_var_matching = invview(var_eq_matching)
    diff_to_var = invview(var_to_diff)
    is_discrete = StateSelection.is_only_discrete(structure)
    linear_eqs = Dict{Int, Int}()
    if mm !== nothing
        for (i, e) in enumerate(mm.nzrows)
            linear_eqs[e] = i
        end
    end

    # We need the inverse mapping of `var_sccs` to update it efficiently later.
    v_to_scc = NTuple{2, Int}[]
    resize!(v_to_scc, ndsts(graph))
    for (i, scc) in enumerate(var_sccs), (j, v) in enumerate(scc)

        v_to_scc[v] = (i, j)
    end
    # Pairs of `(x_t, dx)` added below
    v_t_dvs = NTuple{2, Int}[]

    # For variable x, make dummy derivative x_t if the
    # derivative is in the system
    for v in 1:length(var_to_diff)
        dv = var_to_diff[v]
        # if the variable is not differentiated, there is nothing to do
        dv isa Int || continue
        # if we will solve for the differentiated variable, there is nothing to do
        solved = var_eq_matching[dv] isa Int
        solved && continue

        # If there's `D(x) = x_t` already, update mappings and continue without
        # adding new equations/variables
        dd = find_duplicate_dd(dv, solvable_graph, diff_to_var, linear_eqs, mm)
        if dd === nothing
            # there is no such pre-existing equation
            # generate the dummy derivative variable
            dx = fullvars[dv]
            order, lv = var_order(dv, diff_to_var)
            x_t = is_discrete ? lower_shift_varname_with_unit(fullvars[dv], iv) :
                  MTKBase.lower_varname_with_unit(fullvars[lv], iv, order)

            # Add `x_t` to the graph
            v_t = add_dd_variable!(structure, fullvars, x_t, dv)
            # Add `D(x) - x_t ~ 0` to the graph
            dummy_eq = add_dd_equation!(structure, neweqs, 0 ~ dx - x_t, dv, v_t)
            # Update graph to say, all the equations featuring D(x) also feature x_t
            for e in 𝑑neighbors(graph, dv)
                add_edge!(graph, e, v_t)
            end
            # Update matching
            push!(var_eq_matching, unassigned)
            push!(full_var_eq_matching, unassigned)

            # We also need to substitute all occurrences of `D(x)` with `x_t` in all equations
            # except `dummy_eq`, but that is handled in `generate_system_equations!` since
            # we will solve for `D(x) ~ x_t` and add it to the substitution map.
            dd = dummy_eq, v_t
        end
        # there is a duplicate `D(x) ~ x_t` equation
        # `dummy_eq` is the index of the equation
        # `v_t` is the dummy derivative variable
        dummy_eq, v_t = dd
        var_to_diff[v_t] = var_to_diff[dv]
        old_matched_eq = full_var_eq_matching[dv]
        full_var_eq_matching[dv] = var_eq_matching[dv] = dummy_eq
        full_var_eq_matching[v_t] = old_matched_eq
        eq_var_matching[dummy_eq] = dv
        push!(v_t_dvs, (v_t, dv))
    end

    # tuples of (index, scc) indicating that `scc` has to be inserted at
    # index `index` in `var_sccs`. Same length as `v_t_dvs` because we will
    # have one new SCC per new variable.
    sccs_to_insert = similar(v_t_dvs, Tuple{Int, Vector{Int}})
    # mapping of SCC index to indexes in the SCC to delete
    idxs_to_remove = Dict{Int, Vector{Int}}()
    for (k, (v_t, dv)) in enumerate(v_t_dvs)
        # replace `dv` with `v_t`
        i, j = v_to_scc[dv]
        var_sccs[i][j] = v_t
        if v_t <= length(v_to_scc)
            # v_t wasn't added by this process, it was already present. Which
            # means we need to remove it from whatever SCC it is in, since it is
            # now in this one
            i_, j_ = v_to_scc[v_t]
            scc_del_idxs = get!(() -> Int[], idxs_to_remove, i_)
            push!(scc_del_idxs, j_)
        end
        # `dv` still needs to be present in some SCC. Since we solve for `dv` from
        # `0 ~ D(x) - x_t`, it is in its own SCC. This new singleton SCC must run
        # before the SCC containing var_to_diff[dv] (the 2nd-order derivative), because
        # `generate_system_equations!` populates `total_sub[D(x)] = x_t` when processing
        # this singleton, and the DerivativeDict substitution for D(D(x)) requires D(x)
        # to already be in `total_sub`. If the original SelectedState SCC for `dv` was
        # placed after the 2nd-order derivative SCC in BLT order (e.g. when the dynamics
        # equation has no incidence on `dv`), inserting at position `i` is too late.
        ddv = var_to_diff[dv]
        i_insert = if ddv isa Int && ddv <= length(v_to_scc)
            min(i, v_to_scc[ddv][1])
        else
            i
        end
        sccs_to_insert[k] = (i_insert, [dv])
    end
    sort!(sccs_to_insert, by = first)
    # remove the idxs we need to remove
    for (i, idxs) in idxs_to_remove
        deleteat!(var_sccs[i], idxs)
    end
    new_sccs = insert_sccs(var_sccs, sccs_to_insert)

    if mm !== nothing
        @set! mm.ncols = ndsts(graph)
    end

    return new_sccs
end

"""
    $(TYPEDSIGNATURES)

Given a list of SCCs and a list of SCCs to insert at specific indices, insert them and
return the new SCC vector.
"""
function insert_sccs(
        var_sccs::Vector{Vector{Int}}, sccs_to_insert::Vector{Tuple{Int, Vector{Int}}})
    # insert the new SCCs, accounting for the fact that we might have multiple entries
    # in `sccs_to_insert` to be inserted at the same index.
    old_idx = 1
    insert_idx = 1
    new_sccs = similar(var_sccs, length(var_sccs) + length(sccs_to_insert))
    for i in eachindex(new_sccs)
        # if we have SCCs to insert, and the index we have to insert them at is the current
        # one in the old list of SCCs
        if insert_idx <= length(sccs_to_insert) && sccs_to_insert[insert_idx][1] == old_idx
            # insert it
            new_sccs[i] = sccs_to_insert[insert_idx][2]
            insert_idx += 1
        else
            # otherwise, insert the old SCC
            new_sccs[i] = copy(var_sccs[old_idx])
            old_idx += 1
        end
    end

    filter!(!isempty, new_sccs)
    return new_sccs
end

"""
Check if there's `D(x) ~ x_t` already.
"""
function find_duplicate_dd(dv, solvable_graph, diff_to_var, linear_eqs, mm)
    for eq in 𝑑neighbors(solvable_graph, dv)
        mi = get(linear_eqs, eq, 0)
        iszero(mi) && continue
        row = @view mm[mi, :]
        nzs = nonzeros(row)
        rvs = SparseArrays.nonzeroinds(row)
        # note that `v_t` must not be differentiated
        if length(nzs) == 2 &&
           (abs(nzs[1]) == 1 && nzs[1] == -nzs[2]) &&
           (v_t = rvs[1] == dv ? rvs[2] : rvs[1];
               diff_to_var[v_t] === nothing)
            @assert dv in rvs
            return eq, v_t
        end
    end
    return nothing
end

"""
Add a dummy derivative variable x_t corresponding to symbolic variable D(x)
which has index dv in `fullvars`. Return the new index of x_t.
"""
function add_dd_variable!(s::SystemStructure, fullvars, x_t, dv)
    push!(fullvars, MTKBase.simplify_shifts(x_t))
    push!(s.state_priorities, s.state_priorities[dv])
    v_t = length(fullvars)
    v_t_idx = add_vertex!(s.var_to_diff)
    add_vertex!(s.graph, DST)
    # TODO: do we care about solvable_graph? We don't use them after
    # `dummy_derivative_graph`.
    add_vertex!(s.solvable_graph, DST)
    s.var_to_diff[v_t] = s.var_to_diff[dv]
    v_t
end

"""
Add the equation D(x) - x_t ~ 0 to `neweqs`. `dv` and `v_t` are the indices
of the higher-order derivative variable and the newly-introduced dummy
derivative variable. Return the index of the new equation in `neweqs`.
"""
function add_dd_equation!(s::SystemStructure, neweqs, eq, dv, v_t)
    push!(neweqs, eq)
    add_vertex!(s.graph, SRC)
    dummy_eq = length(neweqs)
    add_edge!(s.graph, dummy_eq, dv)
    add_edge!(s.graph, dummy_eq, v_t)
    add_vertex!(s.solvable_graph, SRC)
    add_edge!(s.solvable_graph, dummy_eq, dv)
    dummy_eq
end

"""
Solve the equations in `neweqs` to obtain the final equations of the
system.

For each equation of `neweqs`, do one of the following:
   1. If the equation is solvable for a differentiated variable D(x),
      then solve for D(x), and add D(x) ~ sol as a differential equation
      of the system.
   2. If the equation is solvable for an un-differentiated variable x,
      solve for x and then add x ~ sol as a solved equation. These will
      become observables.
   3. If the equation is not solvable, add it as an algebraic equation.

Solved equations are added to `total_sub`. Occurrences of differential
or solved variables on the RHS of the final equations will get substituted.
The topological sort of the equations ensures that variables are solved for
before they appear in equations.

Reorder the equations and unknowns to be in the BLT sorted form.

Return the new equations, the solved equations,
the new orderings, and the number of solved variables and equations.
"""
function generate_system_equations!(state::TearingState, neweqs::Vector{Equation},
        var_eq_matching::Matching, full_var_eq_matching::Matching,
        var_sccs::Vector{Vector{Int}}, extra_eqs_vars::NTuple{2, Vector{Int}},
        iv::Union{SymbolicT, Nothing}, D::Union{Differential, Shift, Nothing};
        simplify::Bool = false, inline_linear_sccs = false, analytical_linear_scc_limit = 2,
        allow_symbolic::Bool = false, allow_parameter::Bool = true)
    (; fullvars, sys, structure) = state
    (; solvable_graph, var_to_diff, eq_to_diff, graph) = structure
    eq_var_matching = invview(var_eq_matching)
    full_eq_var_matching = invview(full_var_eq_matching)
    diff_to_var = invview(var_to_diff)
    extra_eqs, extra_vars = extra_eqs_vars

    total_sub = MTKBase.DerivativeDict()
    is_disc = StateSelection.is_only_discrete(structure)
    if is_disc
        for (i, v) in enumerate(fullvars)
            @match v begin
                BSImpl.Term(; f) && if f isa Shift && f.steps < 0 end => begin
                    lowered = lower_shift_varname_with_unit(v, iv)
                    total_sub[v] = lowered
                    fullvars[i] = lowered
                end
                _ => nothing
            end
        end
    end

    eq_generator = EquationGenerator(state, total_sub, D, iv)

    # Inline linear-solve blocks recorded as they are emitted, for the
    # `inline_linear_systems` diagnostic (stored in the system metadata below).
    inline_blocks = InlineLinearSystem[]

    # We need to solve extra equations before everything to repsect
    # topological order.
    for eq in extra_eqs
        var = eq_var_matching[eq]
        var isa Int || continue
        codegen_equation!(eq_generator, neweqs[eq], eq, var; simplify)
    end

    # if the variable is present in the equations either as-is or differentiated
    ispresent = let var_to_diff = var_to_diff, graph = graph
        i -> (!isempty(𝑑neighbors(graph, i)) ||
              (var_to_diff[i] !== nothing && !isempty(𝑑neighbors(graph, var_to_diff[i]))))
    end

    # NOTE: `state.structure.graph` should be accurate despite `generate_system_equations!`
    # mutating the graph (when generating differential equations/populating `total_sub`).
    # If the graph disagrees with symbolic incidence at any point during the execution of
    # this function, then there is some invalid operation happening on the graph.
    digraph = DiCMOBiGraph{false}(graph, var_eq_matching)
    for (i, scc) in enumerate(var_sccs)
        # note that the `vscc <-> escc` relation is a set-to-set mapping, and not
        # point-to-point.
        vscc, escc = get_sorted_scc(digraph, full_var_eq_matching, var_eq_matching, scc)
        var_sccs[i] = vscc
        if length(escc) != length(vscc)
            isempty(escc) && continue
            escc = setdiff(escc, extra_eqs)
            isempty(escc) && continue
            vscc = setdiff(vscc, extra_vars)
            isempty(vscc) && continue
        end

        # Inline linear SCCs pass is only valid on continuous systems. We check if the
        # current SCC is algebraic and if the algebraic equations are linear in the
        # algebraic variables.
        linsol_result = nothing
        if !is_disc && inline_linear_sccs
            linsol_result = get_linear_scc_linsol(state, escc, vscc, neweqs, var_eq_matching, total_sub, analytical_linear_scc_limit, simplify)
        end
        if linsol_result isa Tuple{SymbolicT, BitVector, BitVector}
            linsol, eqs_mask, vars_mask = linsol_result
            @assert length(eqs_mask) == length(escc)
            @assert length(vars_mask) == length(vscc)
            _escc = escc[eqs_mask]
            _vscc = vscc[vars_mask]
            # `linsol` is the `A \ b` term (runtime path); component `j` is solved
            # for the variable assigned below. The analytical path returns a
            # `Const`-wrapped vector instead, which is not reported.
            block_vars = Vector{SymbolicT}(nothing, length(_vscc))
            for (j, (ieq, iv)) in enumerate(zip(_escc, _vscc))
                ∫iv = diff_to_var[iv]
                rhs = linsol[j]
                if ∫iv isa Int
                    order, lv = var_order(iv, diff_to_var)
                    dx = D(fullvars[lv])
                    eq = dx ~ rhs
                    # Differential equation
                    push!(eq_generator.neweqs′, eq)
                    push!(eq_generator.eq_ordering, ieq)
                    push!(eq_generator.var_ordering, ∫iv)
                    for e in 𝑑neighbors(graph, iv)
                        e == ieq && continue
                        for v in 𝑠neighbors(graph, ieq)
                            add_edge!(graph, e, v)
                        end
                        rem_edge!(graph, e, iv)
                    end

                    total_sub[dx] = rhs
                    block_vars[j] = dx
                else
                    var = substitute(fullvars[iv], total_sub)
                    eq = var ~ rhs
                    push!(eq_generator.solved_eqs, eq)
                    push!(eq_generator.solved_vars, iv)
                    block_vars[j] = var
                end
            end
            if SU.iscall(linsol) && SU.operation(linsol) === INLINE_LINEAR_SCC_OP
                push!(inline_blocks,
                    InlineLinearSystem(length(_vscc), block_vars, linsol))
            end

            # Add the eliminated equations later so that the preceding loop
            # can populate `total_sub` appropriately.
            for (i, ieq) in enumerate(escc)
                eqs_mask[i] && continue
                # Currently, if an equation is filtered out it is matched to a variable.
                # This needs to be changed if we update our heuristic.
                var = eq_var_matching[ieq]::Int
                codegen_equation!(eq_generator, neweqs[ieq], ieq, var; simplify)
            end
        else
            for ieq in escc
                iv = eq_var_matching[ieq]
                neq = neweqs[ieq]
                codegen_equation!(eq_generator, neq, ieq, iv; simplify)
            end
        end
    end

    for eq in extra_eqs
        var = eq_var_matching[eq]
        var isa Int && continue
        codegen_equation!(eq_generator, neweqs[eq], eq, var; simplify)
    end

    (; neweqs′, eq_ordering, var_ordering, solved_eqs, solved_vars) = eq_generator

    is_diff_eq = .!iszero.(var_ordering)
    # Generate new equations and orderings
    diff_vars = var_ordering[is_diff_eq]
    diff_vars_set = BitSet(diff_vars)
    if length(diff_vars_set) != length(diff_vars)
        error("Tearing internal error: lowering DAE into semi-implicit ODE failed!")
    end
    solved_vars_set = BitSet(solved_vars)
    # We filled zeros for algebraic variables, so fill them properly here
    offset = 1
    findnextfn = let diff_vars_set = diff_vars_set, solved_vars_set = solved_vars_set,
        diff_to_var = diff_to_var, ispresent = ispresent
        j -> !(j in diff_vars_set || j in solved_vars_set || j in extra_vars) && diff_to_var[j] === nothing &&
            ispresent(j)
    end
    for (i, v) in enumerate(var_ordering)
        v == 0 || continue
        # find the next variable which is not differential or solved, is not the
        # derivative of another variable and is present in the equations
        index = findnext(findnextfn, 1:ndsts(graph), offset)
        # in case of overdetermined systems, this may not be present
        index === nothing && break
        var_ordering[i] = index
        offset = index + 1
    end
    filter!(!iszero, var_ordering)
    var_ordering = [var_ordering; setdiff(1:ndsts(graph), var_ordering, solved_vars_set)]
    neweqs = neweqs′
    return neweqs, solved_eqs, eq_ordering, var_ordering, length(solved_vars),
    length(solved_vars_set), inline_blocks
end

const INLINE_LINEAR_SCC_OP = (\)

"""
    $TYPEDSIGNATURES

If the SCC identified by `alg_eqs` and `alg_vars` warrants a linear solve, return a 3-tuple:

- The expression denoting the solution of the linear system. The linear system
  may be smaller than the SCC.
- A `BitVector` indicating the indices of `alg_eqs` used in the linear system.
- A `BitVector` indicating the indices of `alg_vars` used in the linear system.

All equations not used in the linear system must be solved as normal.
"""
function get_linear_scc_linsol(state::TearingState, alg_eqs::Vector{Int},
                               alg_vars::Vector{Int}, neweqs::Vector{Equation},
                               var_eq_matching::StateSelection.VarEqMatchingT,
                               total_sub::MTKBase.DerivativeDict{SymbolicT, Dict{SymbolicT, SymbolicT}},
                               analytical_linear_scc_limit::Int,
                               simplify::Bool; allow_symbolic::Bool = false,
                               allow_parameter::Bool = true)
    (; fullvars, sys, structure) = state
    (; graph) = structure

    # If the SCC is fully torn, don't bother generating a linsolve
    all_torn = true
    for iv in alg_vars
        all_torn &= var_eq_matching[iv] isa Int && !StateSelection.isdervar(state.structure, iv)
    end
    all_torn && return nothing

    N = length(alg_eqs)
    vars = Symbolics.fixpoint_sub(fullvars[alg_vars], total_sub; maxiters = max(length(total_sub), 10))

    A = StateSelection.CLIL.SparseMatrixCLIL{Num, Int}(N, N, collect(1:N), map(_ -> Int[], 1:N), map(_ -> Num[], 1:N))
    b = fill(Symbolics.COMMON_ZERO, N)

    for (eqidx, ieq) in enumerate(alg_eqs)
        eq = neweqs[ieq]
        resid = eq.rhs
        # If `ieq` is a differential equation
        if !SU._iszero(eq.lhs)
            resid -= eq.lhs
        end
        if simplify
            resid = Symbolics.simplify(resid)
        end
        # Substitute solved differential equations
        resid = Symbolics.fixpoint_sub(
            resid, total_sub, MTKBase.Shift; maxiters = max(2length(total_sub), 10))
        b[eqidx] = resid
    end

    for (varidx, var) in enumerate(vars)
        lex = MTKBase.get_linear_expander_for!(sys, var, true)
        for (eqidx, resid) in enumerate(b)
            Graphs.has_edge(graph, BipartiteEdge(alg_eqs[eqidx], alg_vars[varidx])) || continue
            p, q, islinear = lex(resid)
            islinear || return nothing
            if !SU._iszero(p)
                # We're iterating in increasing `varidx` (column index) so we can just `push!`
                push!(A.row_cols[eqidx], varidx)
                push!(A.row_vals[eqidx], p)
            end
            b[eqidx] = q
        end
    end

    # `-` is important! `b` is on the other side of the equality.
    for i in eachindex(b)
        b[i] = -b[i]
    end

    A, b, eqs_mask, vars_mask = __reduce_linear_system!(A, b, var_eq_matching, alg_eqs, alg_vars)

    N = length(b)
    A = collect(A)::Matrix{Num}

    if N <= analytical_linear_scc_limit && _check_allow_symbolic_parameter(
            state, A, allow_symbolic, allow_parameter
        )
        lu = try
            Symbolics.sym_lu(A)
        catch err
            err isa LinearAlgebra.SingularException || rethrow()
            nothing
        end
        lu !== nothing && return (BSImpl.Const{VartypeT}((lu \ b)::Vector{SymbolicT}), eqs_mask, vars_mask)
    end
    # Turn into symbolic arrays
    sys = state.sys
    # Prefer using a differential variable
    state_idx = findfirst(
        Base.Fix2(isa, SelectedState) ∘ Base.Fix1(getindex, var_eq_matching),
        eachindex(var_eq_matching)
    )
    if state_idx === nothing
        # Find something in `A`
        reference_idx = @something(
            findfirst(iscall ∘ unwrap, A),
            findfirst(!SU.isconst ∘ unwrap, A),
            Some(nothing)
        )
        if reference_idx === nothing
            # Find something in `b`
            reference_idx = @something(
                findfirst(iscall, b),
                findfirst(!SU.isconst, b),
                Some(nothing)
            )
            if reference_idx === nothing
                reference = first(A)
            else
                reference = b[reference_idx]
            end
        else
            reference = A[reference_idx]
        end
    else
        reference = fullvars[state_idx]
    end
    # Use the `ArrayMaker` form for `A` and `b`
    A_regions = SU.RegionsT()
    A_values = Symbolics.SArgsT()
    b_regions = SU.RegionsT()
    b_values = Symbolics.SArgsT()
    # fill the entire thing with zeros
    push!(A_regions, SU.ShapeVecT((1:N, 1:N)))
    push!(A_values, SU.Fill(A_regions[1])(Symbolics.COMMON_ZERO))
    push!(b_regions, SU.ShapeVecT((1:N,)))
    push!(b_values, SU.Fill(b_regions[1])(Symbolics.COMMON_ZERO))

    for i in axes(A, 1), j in axes(A, 2)
        coeff = unwrap(A[i, j])
        SU._iszero(coeff) && continue
        push!(A_regions, SU.ShapeVecT((i:i, j:j)))
        push!(A_values, Symbolics.SConst([coeff;;]))
    end

    for (i, resid) in enumerate(b)
        SU._iszero(resid) && continue
        push!(b_regions, SU.ShapeVecT((i:i,)))
        push!(b_values, Symbolics.SConst([resid]))
    end

    A = SU.ArrayMaker{VartypeT}(A_regions, A_values; shape = SU.ShapeVecT((1:N, 1:N)))
    b = SU.ArrayMaker{VartypeT}(b_regions, b_values; shape = SU.ShapeVecT((1:N,)))

    reference_args = Symbolics.SArgsT((reference, MTKBase.get_iv(sys)::SymbolicT))
    inps = MTKBase.inputs(sys)
    if !isempty(inps)
        push!(reference_args, first(inps))
    end
    reference = Symbolics.STerm(
        promote, reference_args;
        type = Vector{Real}, shape = [1:length(reference_args)]
    )[1]
    sys, A_cache = MTKBase.add_diffcache(sys, N * N)
    A_allocator = A_cache(reference)
    A = SU.Code.with_allocator(A_allocator, SU.Const{VartypeT}(A))
    sys, b_cache = MTKBase.add_diffcache(sys, N)
    b_allocator = b_cache(reference)
    b = SU.Code.with_allocator(b_allocator, SU.Const{VartypeT}(b))
    state.sys = sys

    return (INLINE_LINEAR_SCC_OP(A, b), eqs_mask, vars_mask)
end

function __reduce_linear_system!(A::StateSelection.CLIL.SparseMatrixCLIL{Num, Int}, b::Vector{SymbolicT}, var_eq_matching::StateSelection.VarEqMatchingT, alg_eqs::Vector{Int}, alg_vars::Vector{Int})
    N = length(b)
    # Identify rows (equations) not worth involving in the linear solve.
    #
    # The current heuristic is to find all rows with constant coefficients
    # which are matched to a variable in `var_eq_matching`.
    eqs_mask = trues(N)
    vars_mask = trues(N)
    new_N = N
    eq_var_matching = invview(var_eq_matching)
    var_to_idx = Dict{Int, Int}(Iterators.map(reverse, enumerate(alg_vars)))
    # The `i`th variable in the SCC is eliminated as
    # `∑_k aliases[i][k] * fullvars[alg_vars[k]] + constants[i]`
    constants = Dict{Int, SymbolicT}()
    aliases = Dict{Int, SparseArrays.SparseVector{Num, Int}}()
    for (i, coeffs) in enumerate(A.row_vals)
        all(SU.isconst ∘ unwrap, coeffs) || continue
        eq_var_matching[alg_eqs[i]] isa Int || continue

        eqs_mask[i] = false
        var = eq_var_matching[alg_eqs[i]]::Int
        ivar = var_to_idx[var]
        vars_mask[ivar] = false
        new_N -= 1

        eqvars = A.row_cols[i]
        idx_in_eq = findfirst(isequal(ivar), eqvars)::Int
        var_coeff = coeffs[idx_in_eq]
        deleteat!(eqvars, idx_in_eq)
        deleteat!(coeffs, idx_in_eq)
        # Negation to move variables to the other side of the equality
        coeffs ./= -var_coeff
        aliases[ivar] = SparseArrays.SparseVector(N, eqvars, coeffs)
        # `b` is already on the other side of the equality
        constants[ivar] = b[i] / var_coeff
    end

    # We could have eliminated a variable in terms of other eliminated variables. While
    # `get_new_mm` can handle this, it makes updating `b` much more difficult. We can
    # topologically sort the dependency graph and use this information to update `aliases`
    # and `constants` to fix this issue.
    dep_graph = Graphs.SimpleDiGraph(length(alg_vars))
    for (var, coeffs) in aliases
        I, _ = SparseArrays.findnz(coeffs)
        for other_var in I
            # Avoid unnecessary edges.
            haskey(aliases, other_var) || continue
            # Edge from dependency to dependent
            Graphs.add_edge!(dep_graph, other_var, var)
        end
    end

    # We know there won't be cycles because we're using the results of tearing, which
    # partitioned this SCC into a lower
    var_order = Graphs.topological_sort(dep_graph)
    for var in var_order
        haskey(aliases, var) || continue
        iszero(Graphs.indegree(dep_graph, var)) && continue
        coeffs = aliases[var]
        cst = constants[var]
        I, V = SparseArrays.findnz(coeffs)

        new_I = Int[]
        new_V = Num[]
        sizehint!(new_I, length(I))
        sizehint!(new_V, length(V))
        for (other_var, coeff) in zip(I, V)
            other_coeffs = get(aliases, other_var, nothing)
            if other_coeffs === nothing
                push!(new_I, other_var)
                push!(new_V, coeff)
                continue
            end
            other_coeffs = other_coeffs::valtype(aliases)
            other_cst = constants[other_var]
            other_I, other_V = SparseArrays.findnz(other_coeffs)
            append!(new_I, other_I)
            append!(new_V, Iterators.map(Base.Fix2(*, coeff), other_V))
            cst += coeff * other_cst
        end

        # `sparsevec` sums duplicate indices but keeps explicit zeros; drop them.
        aliases[var] = SparseArrays.dropzeros!(SparseArrays.sparsevec(new_I, new_V, length(coeffs)))
        constants[var] = cst
    end

    # First we update `b`, since doing so requires the unmodified `A`.
    for i in 1:N
        # Don't bother updating equations we'll delete
        eqs_mask[i] || continue
        eqvars = A.row_cols[i]
        eqcoeffs = A.row_vals[i]
        for (var, coeff) in zip(eqvars, eqcoeffs)
            # Ignore variables we'll retain
            vars_mask[var] && continue
            # This variable is deleted. `constants` stores its equation's constant RHS,
            # so add the corresponding scaled value to this equation's RHS. Note that in
            # `A x = b` we're effectively substituting on the LHS, so we use `-=` to move
            # the constant term to the RHS.
            b[i] -= coeff * constants[var]
        end
    end
    b = b[eqs_mask]
    # Now, update `A` and `b`
    # Will give the new index of each variable in `A` for indices where `vars_mask[i] == true`
    old_to_new_var = cumsum(vars_mask)
    old_to_new_var[.!vars_mask] .= 0
    old_to_new_eq = cumsum(eqs_mask)
    old_to_new_eq[.!eqs_mask] .= 0
    A = StateSelection.get_new_mm(aliases, old_to_new_eq, old_to_new_var, A)

    return A, b, eqs_mask, vars_mask
end

"""
    $(TYPEDSIGNATURES)

Sort the provided SCC `scc`, given the `digraph` of the system constructed using
`var_eq_matching` along with both the matchings of the system.
"""
function get_sorted_scc(
        digraph::DiCMOBiGraph, full_var_eq_matching::Matching, var_eq_matching::Matching, scc::Vector{Int})
    eq_var_matching = invview(var_eq_matching)
    # obtain the matched equations in the SCC
    scc_eqs = Int[]
    # obtain the equations in the SCC that are linearly solvable
    scc_solved_eqs = Int[]
    for v in scc
        e = full_var_eq_matching[v]
        if e isa Int
            push!(scc_eqs, e)
        end
        e = var_eq_matching[v]
        if e isa Int
            push!(scc_solved_eqs, e)
        end
    end
    # obtain the subgraph of the contracted graph involving the solved equations
    subgraph, varmap = Graphs.induced_subgraph(digraph, scc_solved_eqs)
    # topologically sort the solved equations and append the remainder
    scc_eqs = [varmap[reverse(topological_sort(subgraph))];
               setdiff(scc_eqs, scc_solved_eqs)]
    # the variables of the SCC are obtained by inverse mapping the sorted equations
    # and appending the rest
    scc_vars = Int[]
    for e in scc_eqs
        v = eq_var_matching[e]
        if v isa Int
            push!(scc_vars, v)
        end
    end
    append!(scc_vars, setdiff(scc, scc_vars))
    return scc_vars, scc_eqs
end

"""
    $(TYPEDSIGNATURES)

Struct containing the information required to generate equations of a system, as well as
the generated equations and associated metadata.
"""
struct EquationGenerator{S}
    """
    `TearingState` of the system.
    """
    state::S
    """
    Substitutions to perform in all subsequent equations. For each differential equation
    `D(x) ~ f(..)`, the substitution `D(x) => f(..)` is added to the rules.
    """
    total_sub::MTKBase.DerivativeDict{SymbolicT, Dict{SymbolicT, SymbolicT}}
    """
    The differential operator, or `nothing` if not applicable.
    """
    D::Union{Differential, Shift, Nothing}
    """
    The independent variable, or `nothing` if not applicable.
    """
    idep::Union{SymbolicT, Nothing}
    """
    The new generated equations of the system.
    """
    neweqs′::Vector{Equation}
    """
    `eq_ordering[i]` is the index `neweqs′[i]` was originally at in the untorn equations of
    the system. This is used to permute the state of the system into BLT sorted form.
    """
    eq_ordering::Vector{Int}
    """
    `var_ordering[i]` is the index in `state.fullvars` of the variable at the `i`th index in
    the BLT sorted form.
    """
    var_ordering::Vector{Int}
    """
    List of linearly solved (observed) equations.
    """
    solved_eqs::Vector{Equation}
    """
    `eq_ordering` for `solved_eqs`.
    """
    solved_vars::Vector{Int}
end

function EquationGenerator(state, total_sub, D, idep)
    EquationGenerator(
        state, total_sub, D, idep, Equation[], Int[], Int[], Equation[], Int[])
end

"""
    $(TYPEDSIGNATURES)

Check if equation at index `ieq` is linearly solvable for variable at index `iv`.
"""
function is_solvable(eg::EquationGenerator, ieq, iv)
    solvable_graph = eg.state.structure.solvable_graph::BipartiteGraph{Int, Nothing}
    return ieq isa Int && iv isa Int && BipartiteEdge(ieq, iv) in solvable_graph
end

"""
    $(TYPEDSIGNATURES)

    If `iv` is like D(x) or Shift(t, 1)(x)
"""
is_dervar(eg::EquationGenerator, iv::Int) = StateSelection.isdervar(eg.state.structure, iv)

"""
    $(TYPEDSIGNATURES)

Appropriately codegen the given equation `eq`, which occurs at index `ieq` in the untorn
list of equations and is matched to variable at index `iv`.
"""
function codegen_equation!(eg::EquationGenerator,
        eq::Equation, ieq::Int, iv::Union{Int, Unassigned}; simplify = false)
    # We generate equations ordered by the matched variables
    #   Solvable equations of differential variables D(x) become differential equations
    #   Solvable equations of non-differential variables become observable equations
    #   Non-solvable equations become algebraic equations.
    (; state, total_sub, neweqs′, eq_ordering, var_ordering) = eg
    (; solved_eqs, solved_vars, D, idep) = eg
    (; fullvars, sys, structure) = state
    (; var_to_diff, graph) = structure
    diff_to_var = invview(var_to_diff)

    issolvable = is_solvable(eg, ieq, iv)
    isdervar = issolvable && is_dervar(eg, iv)
    isdisc = StateSelection.is_only_discrete(structure)
    # The variable is derivative variable and the "most differentiated"
    # This is only used for discrete systems, and basically refers to
    # `Shift(t, 1)(x(k))` in `Shift(t, 1)(x(k)) ~ x(k) + x(k-1)`. As illustrated in
    # the docstring for `add_additional_history!`, this is an exception and needs to be
    # treated like a solved equation rather than a differential equation.
    is_highest_diff = iv isa Int && isdervar && var_to_diff[iv] === nothing
    if issolvable && isdervar && (!isdisc || !is_highest_diff)
        var = fullvars[iv]
        isnothing(D) && throw(UnexpectedDifferentialError(equations(sys)[ieq]))
        order, lv = var_order(iv, diff_to_var)
        dx = D(MTKBase.simplify_shifts(fullvars[lv]))
        neweq = make_differential_equation(var, dx, eq, total_sub)
        # We will add `neweq.lhs` to `total_sub`, so any equation involving it won't be
        # incident on it. Remove the edges incident on `iv` from the graph, and add
        # the replacement vertices from `ieq` so that the incidence is still correct.
        #
        # The `copy` is necessary because `rem_edge!` will mutate the buffer that we
        # iterate over.
        for e in copy(𝑑neighbors(graph, iv))
            e == ieq && continue
            for v in 𝑠neighbors(graph, ieq)
                add_edge!(graph, e, v)
            end
            rem_edge!(graph, e, iv)
        end

        total_sub[MTKBase.simplify_shifts(neweq.lhs)] = neweq.rhs
        # Substitute unshifted variables x(k), y(k) on RHS of implicit equations
        if StateSelection.is_only_discrete(structure)
            var_to_diff[iv] === nothing && (total_sub[var] = neweq.rhs)
        end
        push!(neweqs′, neweq)
        push!(eq_ordering, ieq)
        push!(var_ordering, diff_to_var[iv])
    elseif issolvable
        var = fullvars[iv]
        neweq = make_solved_equation(var, eq, total_sub; simplify)
        if neweq !== nothing
            # backshift solved equations to calculate the value of the variable at the
            # current time. This works because we added one additional history element
            # in `add_additional_history!`.
            if isdisc
                neweq = backshift_expr(neweq, idep::SymbolicT)::Equation
            end
            push!(solved_eqs, neweq)
            push!(solved_vars, iv)
        end
    else
        neweq = make_algebraic_equation(eq, total_sub)
        # For the same reason as solved equations (they are effectively the same)
        if isdisc
            neweq = backshift_expr(neweq, idep::SymbolicT)
        end
        push!(neweqs′, neweq)
        push!(eq_ordering, ieq)
        # we push a dummy to `var_ordering` here because `iv` is `unassigned`
        push!(var_ordering, 0)
    end
end

"""
Occurs when a variable D(x) occurs in a non-differential system.
"""
struct UnexpectedDifferentialError
    eq::Equation
end

function Base.showerror(io::IO, err::UnexpectedDifferentialError)
    error("Differential found in a non-differential system. Likely this is a bug in the construction of an initialization system. Please report this issue with a reproducible example. Offending equation: $(err.eq)")
end

"""
Generate a first-order differential equation whose LHS is `dx`.

`var` and `dx` represent the same variable, but `var` may be a higher-order differential and `dx` is always first-order. For example, if `var` is D(D(x)), then `dx` would be `D(x_t)`. Solve `eq` for `var`, substitute previously solved variables, and return the differential equation.
"""
function make_differential_equation(var, dx, eq, total_sub)
    v1 = Symbolics.symbolic_linear_solve(eq, var)::SymbolicT
    v2 = Symbolics.fixpoint_sub(v1, total_sub, MTKBase.Shift)
    v3 = MTKBase.simplify_shifts(v2)
    dx ~ v3
end

"""
Generate an algebraic equation. Substitute solved variables into `eq` and return the equation.
"""
function make_algebraic_equation(eq, total_sub)
    rhs = eq.rhs - eq.lhs
    0 ~ MTKBase.simplify_shifts(Symbolics.fixpoint_sub(rhs, total_sub))
end

"""
Solve equation `eq` for `var`, substitute previously solved variables, and return the solved equation.
"""
function make_solved_equation(var, eq, total_sub; simplify = false)
    residual = eq.lhs - eq.rhs
    a, b, islinear = Symbolics.linear_expansion(residual, var)
    # 0 ~ a * var + b
    # var ~ -b/a
    if SU._iszero(a)
        @warn "Tearing: solving $eq for $var is singular!"
        return nothing
    else
        rhs = -b / a
        return var ~ MTKBase.simplify_shifts(Symbolics.fixpoint_sub(
            simplify ?
            Symbolics.simplify(rhs) : rhs,
            total_sub, MTKBase.Shift))
    end
end

"""
Given the ordering returned by `generate_system_equations!`, update the
tearing state to account for the new order. Permute the variables and equations.
Eliminate the solved variables and equations from the graph and permute the
graph's vertices to account for the new variable/equation ordering.
"""
function reorder_vars!(state::TearingState, var_eq_matching, var_sccs, eq_ordering,
        var_ordering, nsolved_eq, nsolved_var)
    (; solvable_graph, var_to_diff, eq_to_diff, graph) = state.structure

    eqsperm = zeros(Int, nsrcs(graph))
    for (i, v) in enumerate(eq_ordering)
        eqsperm[v] = i
    end
    varsperm = zeros(Int, ndsts(graph))
    for (i, v) in enumerate(var_ordering)
        varsperm[v] = i
    end

    # Contract the vertices in the structure graph to make the structure match
    # the new reality of the system we've just created.
    new_graph = StateSelection.contract_variables(graph, var_eq_matching, varsperm, eqsperm,
        nsolved_eq, nsolved_var)
    new_solvable_graph = StateSelection.contract_variables(solvable_graph, var_eq_matching, varsperm, eqsperm,
        nsolved_eq, nsolved_var)

    new_var_to_diff = complete(StateSelection.DiffGraph(length(var_ordering)))
    for (v, d) in enumerate(var_to_diff)
        v′ = varsperm[v]
        (v′ > 0 && d !== nothing) || continue
        d′ = varsperm[d]
        new_var_to_diff[v′] = d′ > 0 ? d′ : nothing
    end
    new_eq_to_diff = complete(StateSelection.DiffGraph(length(eq_ordering)))
    for (v, d) in enumerate(eq_to_diff)
        v′ = eqsperm[v]
        (v′ > 0 && d !== nothing) || continue
        d′ = eqsperm[d]
        new_eq_to_diff[v′] = d′ > 0 ? d′ : nothing
    end
    new_fullvars = state.fullvars[var_ordering]

    # Update the SCCs
    var_ordering_set = BitSet(var_ordering)
    for scc in var_sccs
        # Map variables to their new indices
        map!(Base.Fix1(getindex, varsperm), scc, scc)
        # Remove variables not in the reduced set
        filter!(!iszero, scc)
    end
    # Remove empty SCCs
    filter!(!isempty, var_sccs)

    # Update system structure
    @set! state.structure.graph = complete(new_graph)
    @set! state.structure.solvable_graph = complete(new_solvable_graph)
    @set! state.structure.var_to_diff = new_var_to_diff
    @set! state.structure.eq_to_diff = new_eq_to_diff
    @set! state.fullvars = new_fullvars
    state
end

"""
Update the system equations, unknowns, and observables after simplification.
"""
function update_simplified_system!(
        state::TearingState, neweqs::Vector{Equation}, solved_eqs::Vector{Equation},
        dummy_sub::Dict{SymbolicT, SymbolicT}, var_sccs::Vector{Vector{Int}},
        extra_unknowns::Vector{SymbolicT}, iv::Union{SymbolicT, Nothing},
        D::Union{Differential, Shift, Nothing}; array_hack = true)
    (; fullvars, structure) = state
    (; solvable_graph, var_to_diff, eq_to_diff, graph) = structure
    diff_to_var = invview(var_to_diff)
    # Since we solved the highest order derivative variable in discrete systems,
    # we make a list of the solved variables and avoid including them in the
    # unknowns.
    solved_vars = Set{SymbolicT}()
    if StateSelection.is_only_discrete(structure)
        iv = iv::SymbolicT
        D = D::Shift
        for eq in solved_eqs
            var = eq.lhs
            if isequal(eq.lhs, eq.rhs)
                var = lower_shift_varname_with_unit(D(eq.lhs), iv)
            end
            push!(solved_vars, var)
        end
        filter!(eq -> !isequal(eq.lhs, eq.rhs), solved_eqs)
    end

    ispresent = let var_to_diff = var_to_diff, graph = graph
        i -> (!isempty(𝑑neighbors(graph, i)) ||
              (var_to_diff[i] !== nothing && !isempty(𝑑neighbors(graph, var_to_diff[i]))))
    end

    sys = state.sys
    obs_sub = dummy_sub
    for eq in neweqs
        MTKBase.isdiffeq(eq) || continue
        obs_sub[eq.lhs] = eq.rhs
    end
    (; additional_observed) = state
    if StateSelection.is_only_discrete(structure)
        additional_observed = map(Base.Fix2(backshift_expr, iv), additional_observed)
    end
    # TODO: compute the dependency correctly so that we don't have to do this
    obs = [substitute(observed(sys), obs_sub); solved_eqs;
           substitute(additional_observed, obs_sub)]

    filterer = let diff_to_var = diff_to_var, ispresent = ispresent, fullvars = fullvars,
        solved_vars = solved_vars
        i -> diff_to_var[i] === nothing && ispresent(i) && !(fullvars[i] in solved_vars)
    end
    unknown_idxs = filter(filterer, eachindex(state.fullvars))
    unknowns = state.fullvars[unknown_idxs]
    unknowns = [unknowns; extra_unknowns]
    # `generate_system_equations!` will include the extra unknowns in `var_ordering` due to
    # the `setdiff` at the end. Excluding them leads to issues when running `singularity_check`
    # on the simplified `state` in `InitializationProblem`. However, `ispresent` can filter
    # some of them out of `unknown_idxs` if they don't occur in the selected equations. As
    # a result, we still add them here. `unique!` serves to remove duplicates. Otherwise,
    # `tearing_hacks` may count an array variable occuring `length + 1` times in
    # unknowns+observables, and will thus not add the `x ~ [x[1], x[2]...]` array hack
    # observed equation.
    unique!(unknowns)
    if StateSelection.is_only_discrete(structure)
        # Algebraic variables are shifted forward by one, so we backshift them.
        _unknowns = SymbolicT[]
        for var in unknowns
            @match var begin
                BSImpl.Term(; f, args, type, shape, metadata) && if f isa Shift && f.steps == 1 end => begin
                    push!(_unknowns, args[1])
                end
                _ => push!(_unknowns, var)
            end
        end
        unknowns = _unknowns
    end
    @set! sys.unknowns = unknowns

    obs = (@invokelatest tearing_hacks(sys, obs, unknowns, neweqs; array = array_hack))::Vector{Equation}

    @set! sys.eqs = neweqs
    @set! sys.observed = obs

    # Only makes sense for time-dependent
    if MTKBase.has_schedule(sys)
        unknowns_set = BitSet(unknown_idxs)
        for scc in var_sccs
            intersect!(scc, unknowns_set)
        end
        filter!(!isempty, var_sccs)
        @set! sys.schedule = MTKBase.Schedule(var_sccs, dummy_sub)
    end
    if MTKBase.has_isscheduled(sys)
        @set! sys.isscheduled = true
    end
    return sys
end

"""
Give the order of the variable indexed by dv.
"""
function var_order(dv, diff_to_var)
    order = 0
    while (dv′ = diff_to_var[dv]) !== nothing
        order += 1
        dv = dv′
    end
    order, dv
end

"""
Main internal function for structural simplification for DAE systems and discrete systems.
Generate dummy derivative variables, new equations in terms of variables, return updated
system and tearing state.

Terminology and Definition:

A general DAE is in the form of `F(u'(t), u(t), p, t) == 0`. We can
characterize variables in `u(t)` into two classes: differential variables
(denoted `v(t)`) and algebraic variables (denoted `z(t)`). Differential
variables are marked as `SelectedState` and they are differentiated in the
DAE system, i.e. `v'(t)` are all the variables in `u'(t)` that actually
appear in the system. Algebraic variables are variables that are not
differential variables.

# Arguments

- `state`: The `TearingState` of the system.
- `var_eq_matching`: The maximal matching after state selection.
- `full_var_eq_matching`: The maximal matching prior to state selection.
- `var_sccs`: The topologically sorted strongly connected components of the system
  according to `full_var_eq_matching`.

# Options

$TYPEDFIELDS
"""
@kwdef struct DefaultReassembleAlgorithm <: ReassembleAlgorithm
    """
    Whether to use `SymbolicUtils.simplify` when generating the equations.
    """
    simplify::Bool = false
    """
    Experimental toggle for disabling passes that aid in code generation of arrays.
    """
    array_hack::Bool = true
    """
    Whether SCCs which are linear systems of the associated variables should be
    handled using inline linear solves via `LinearSolve.jl`. By default, such
    SCCs generate algebraic equations.
    """
    inline_linear_sccs::Bool = false
    """
    If `inline_linear_sccs == true`, this is the maximum size of a system of linear
    equations which is solved symbolically rather than using `LinearSolve.jl`.
    """
    analytical_linear_scc_limit::Int = 2
end

function (alg::DefaultReassembleAlgorithm)(state::TearingState,
                                           tearing_result::StateSelection.TearingResult,
                                           mm::Union{CLIL.SparseMatrixCLIL,  Nothing};
                                           fully_determined::Bool = true,
                                           allow_symbolic::Bool = false,
                                           allow_parameter::Bool = true, kw...)
    (; simplify, array_hack, inline_linear_sccs, analytical_linear_scc_limit) = alg
    (; var_eq_matching, full_var_eq_matching, var_sccs) = tearing_result


    extra_eqs_vars = get_extra_eqs_vars(
        state, var_eq_matching, full_var_eq_matching, fully_determined)
    neweqs = collect(equations(state))
    dummy_sub = Dict{SymbolicT, SymbolicT}()

    if MTKBase.has_iv(state.sys) && MTKBase.get_iv(state.sys) !== nothing
        iv = MTKBase.get_iv(state.sys)::SymbolicT
        if !StateSelection.is_only_discrete(state.structure)
            D = Differential(iv)
        else
            D = Shift(iv, 1)
        end
    else
        iv = D = nothing
    end
    # `iv === nothing` implies a nonlinear system. `SCCNonlinearProblem` should be
    # used instead of this pass. `D isa Shift` implies a discrete system, which currently
    # doesn't support inline linear SCCs.
    if iv === nothing || D isa Shift
        inline_linear_sccs = false
    end

    extra_unknowns = state.fullvars[extra_eqs_vars[2]]
    if StateSelection.is_only_discrete(state.structure)
        var_sccs = add_additional_history!(
            state, var_eq_matching, full_var_eq_matching, var_sccs, iv::SymbolicT)
    end

    # Structural simplification
    if iv isa SymbolicT # Without iv we don't have derivatives
        D = D::Union{Differential, Shift}
        substitute_derivatives_algevars!(state, neweqs, var_eq_matching, dummy_sub, iv, D)

        var_sccs = generate_derivative_variables!(
            state, neweqs, var_eq_matching, full_var_eq_matching, var_sccs, mm, iv)
    end
    if iv isa SymbolicT
        D = D::Union{Differential, Shift}
        neweqs, solved_eqs,
        eq_ordering,
        var_ordering,
        nelim_eq,
        nelim_var,
        inline_blocks = generate_system_equations!(
            state, neweqs, var_eq_matching, full_var_eq_matching,
            var_sccs, extra_eqs_vars, iv, D; simplify, inline_linear_sccs,
            analytical_linear_scc_limit, allow_symbolic, allow_parameter)
        state = reorder_vars!(
            state, var_eq_matching, var_sccs, eq_ordering, var_ordering, nelim_eq, nelim_var)
        # var_eq_matching and full_var_eq_matching are now invalidated

        sys = update_simplified_system!(state, neweqs, solved_eqs, dummy_sub, var_sccs,
            extra_unknowns, iv, D; array_hack)
    else
        D = D::Nothing
        neweqs, solved_eqs,
            eq_ordering,
            var_ordering,
            nelim_eq,
            nelim_var,
            inline_blocks = generate_system_equations!(
                state, neweqs, var_eq_matching, full_var_eq_matching,
                var_sccs, extra_eqs_vars, iv, D; simplify, inline_linear_sccs,
                analytical_linear_scc_limit)
        state = reorder_vars!(
            state, var_eq_matching, var_sccs, eq_ordering, var_ordering, nelim_eq, nelim_var)
        # var_eq_matching and full_var_eq_matching are now invalidated

        sys = update_simplified_system!(state, neweqs, solved_eqs, dummy_sub, var_sccs,
            extra_unknowns, iv, D; array_hack)
    end

    sys = SU.setmetadata(sys, InlineLinearSystemsMetadata, inline_blocks)
    @set! state.sys = sys
    @set! sys.tearing_state = state
    return MTKBase.invalidate_cache!(sys)
end

function inline_linear_sccs_preprocessing!(state::TearingState, iv::SymbolicT, var_sccs::Vector{Vector{Int}})
    (; structure) = state
    if StateSelection.is_only_discrete(structure)
        error("Inline linear SCC pass is not valid on discrete systems!")
    end

    
end

"""
    $(TYPEDSIGNATURES)

Add one more history equation for discrete systems. For example, if we have

```julia
Shift(t, 1)(x(k-1)) ~ x(k)
Shift(t, 1)(x(k)) ~ x(k) + x(k-1)
```

This turns it into

```julia
Shift(t, 1)(x(k-2)) ~ x(k-1)
Shift(t, 1)(x(k-1)) ~ x(k)
Shift(t, 1)(x(k)) ~ x(k) + x(k-1)
```

Thus adding an additional unknown as well. Later, the highest derivative equation will
be backshifted by one and turned into an observed equation, resulting in:

```julia
Shift(t, 1)(x(k-2)) ~ x(k-1)
Shift(t, 1)(x(k-1)) ~ x(k)

x(k) ~ x(k-1) + x(k-2)
```

Where the last equation is the observed equation.
"""
function add_additional_history!(
        state::TearingState, var_eq_matching::Matching,
        full_var_eq_matching::Matching, var_sccs::Vector{Vector{Int}}, iv::Union{SymbolicT, Nothing})
    iv === nothing && return var_sccs
    iv = iv::SymbolicT
    (; fullvars, sys, structure) = state
    (; solvable_graph, var_to_diff, eq_to_diff, graph) = structure
    diff_to_var = invview(var_to_diff)

    # We need the inverse mapping of `var_sccs` to update it efficiently later.
    v_to_scc = NTuple{2, Int}[]
    resize!(v_to_scc, ndsts(graph))
    for (i, scc) in enumerate(var_sccs), (j, v) in enumerate(scc)

        v_to_scc[v] = (i, j)
    end

    vars_to_backshift = BitSet()
    # add history for differential variables
    for ivar in 1:length(fullvars)
        ieq = var_eq_matching[ivar]
        # the variable to backshift is a state variable which is not the
        # derivative of any other one.
        ieq isa SelectedState || continue
        diff_to_var[ivar] === nothing || continue
        push!(vars_to_backshift, ivar)
    end

    inserts = Tuple{Int, Vector{Int}}[]

    for var in vars_to_backshift
        add_backshifted_var!(state, var, iv)
        # all backshifted vars are differential vars, hence SelectedState
        push!(var_eq_matching, SelectedState())
        push!(full_var_eq_matching, unassigned)
        # add to the SCCs right before the variable that was backshifted
        push!(inserts, (v_to_scc[var][1], [length(fullvars)]))
    end

    sort!(inserts, by = first)
    new_sccs = insert_sccs(var_sccs, inserts)
    return new_sccs
end

"""
    $(TYPEDSIGNATURES)

Add the backshifted version of variable `ivar` to the system.
"""
function add_backshifted_var!(state::TearingState, ivar::Int, iv)
    (; fullvars, structure) = state
    (; var_to_diff, graph, solvable_graph) = structure

    var = fullvars[ivar]
    newvar = MTKBase.simplify_shifts(Shift(iv, -1)(var))
    push!(fullvars, newvar)
    push!(structure.state_priorities, structure.state_priorities[ivar])
    inewvar = add_vertex!(var_to_diff)
    add_edge!(var_to_diff, inewvar, ivar)
    add_vertex!(graph, DST)
    add_vertex!(solvable_graph, DST)
    return inewvar
end

"""
    $(TYPEDSIGNATURES)

Backshift the given expression `ex`.
"""
function backshift_expr(ex, iv)
    ex isa SymbolicT || return ex
    return descend_lower_shift_varname_with_unit(
        MTKBase.simplify_shifts(MTKBase.distribute_shift(Shift(iv, -1)(ex))), iv)::SymbolicT
end

function backshift_expr(ex::Equation, iv)
    return backshift_expr(ex.lhs, iv) ~ backshift_expr(ex.rhs, iv)
end

"""
    $(TYPEDSIGNATURES)

Return a 2-tuple of integer vectors containing indices of extra equations and variables
respectively. For fully-determined systems, both of these are empty. Overdetermined systems
have extra equations, and underdetermined systems have extra variables.
"""
function get_extra_eqs_vars(
        state::TearingState, var_eq_matching::Matching, full_var_eq_matching::Matching, fully_determined::Bool)
    fully_determined && return Int[], Int[]

    extra_eqs = Int[]
    extra_vars = Int[]
    full_eq_var_matching = invview(full_var_eq_matching)

    for v in 𝑑vertices(state.structure.graph)
        eq = full_var_eq_matching[v]
        eq isa Int && continue
        # Only if the variable is also unmatched in `var_eq_matching`.
        # Otherwise, `SelectedState` differential variables from order lowering
        # are also considered "extra"
        var_eq_matching[v] === unassigned || continue
        push!(extra_vars, v)
    end
    for eq in 𝑠vertices(state.structure.graph)
        v = full_eq_var_matching[eq]
        v isa Int && continue
        push!(extra_eqs, eq)
    end

    return extra_eqs, extra_vars
end

"""
# HACK

Add equations for array observed variables. If `p[i] ~ (...)` are equations, add an
equation `p ~ [p[1], p[2], ...]` allow topsort to reorder them only add the new equation
if all `p[i]` are present and the unscalarized form is used in any equation (observed or
not) we first count the number of times the scalarized form of each observed variable
occurs in observed equations (and unknowns if it's split).
"""
function tearing_hacks(sys, obs, unknowns, neweqs; array = true)
    # map of array observed variable (unscalarized) to number of its
    # scalarized terms that appear in observed equations
    arr_obs_occurrences = Dict{SymbolicT, Int}()
    for (i, eq) in enumerate(obs)
        lhs = eq.lhs
        rhs = eq.rhs

        array || continue
        Moshi.Match.@match lhs begin
            BSImpl.Term(; f, args) && if f === getindex end => begin
                arg1 = args[1]
                cnt = get(arr_obs_occurrences, arg1, 0)
                arr_obs_occurrences[arg1] = cnt + 1
            end
            _ => nothing
        end
    end

    # count variables in unknowns if they are scalarized forms of variables
    # also present as observed. e.g. if `x[1]` is an unknown and `x[2] ~ (..)`
    # is an observed equation.
    for sym in unknowns
        Moshi.Match.@match sym begin
            BSImpl.Term(; f, args, shape) && if f === getindex end => begin
                shape isa SU.Unknown && continue
                arg1 = args[1]
                cnt = get(arr_obs_occurrences, arg1, 0)
                cnt == 0 && continue
                arr_obs_occurrences[arg1] = cnt + 1
            end
            _ => nothing
        end
    end

    obs_arr_eqs = Equation[]
    for (arrvar, cnt) in arr_obs_occurrences
        cnt == length(arrvar) || continue
        # firstindex returns 1 for multidimensional array symbolics
        firstind = Tuple(first(eachindex(arrvar)))
        scal = [arrvar[i] for i in eachindex(arrvar)]
        # respect non-1-indexed arrays
        # TODO: get rid of this hack together with the above hack, then remove OffsetArrays dependency
        # `change_origin` is required because `Origin(firstind)(scal)` makes codegen
        # try to `create_array(OffsetArray{...}, ...)` which errors.
        # `term(Origin(firstind), scal)` doesn't retain the `symtype` and `size`
        # of `scal`.
        if all(isone, firstind)
            rhs = scal
        else
            rhs = change_origin(firstind, scal)
        end
        push!(obs_arr_eqs, arrvar ~ rhs)
    end
    append!(obs, obs_arr_eqs)

    return obs
end

# PART OF HACK
function change_origin(origin, arr)
    if all(isone, origin)
        return arr
    end
    return Origin(origin)(arr)
end

@register_array_symbolic change_origin(origin::Any, arr::AbstractArray) begin
    size = size(arr)
    eltype = eltype(arr)
    ndims = ndims(arr)
end

"""
    $TYPEDEF

An struct implementing [`StateSelection.SystemStructure`](@ref) for
[`ModelingToolkitBase.System`](@ref).

# Fields

$TYPEDFIELDS
"""
Base.@kwdef mutable struct SystemStructure <: StateSelection.SystemStructure
    """Maps the index of variable x to the index of variable D(x)."""
    var_to_diff::StateSelection.DiffGraph
    """Maps the index of an algebraic equation to the index of the equation it is differentiated into."""
    eq_to_diff::StateSelection.DiffGraph
    """Graph that connects equations to variables that appear in them."""
    graph::BipartiteGraph{Int, Nothing}
    """Graph that connects equations to the variable they will be solved for during simplification."""
    solvable_graph::Union{BipartiteGraph{Int, Nothing}, Nothing}
    """Variable types (brownian, variable, parameter) in the system."""
    var_types::Vector{VariableType}
    """State priorities corresponding to each variable in `fullvars`"""
    state_priorities::Vector{Int}
    """Whether the system is discrete."""
    only_discrete::Bool
end

function Base.copy(structure::SystemStructure)
    var_types = structure.var_types === nothing ? nothing : copy(structure.var_types)
    SystemStructure(copy(structure.var_to_diff), copy(structure.eq_to_diff),
        copy(structure.graph), copy(structure.solvable_graph),
        var_types, copy(structure.state_priorities), structure.only_discrete)
end

StateSelection.is_only_discrete(s::SystemStructure) = s.only_discrete

"""
    $TYPEDEF

An implementation of [`StateSelection.TransformationState`](@ref) for
[`ModelingToolkitBase.System`](@ref).

# Fields

$TYPEDFIELDS
"""
mutable struct TearingState <: StateSelection.TransformationState{System}
    """The system of equations."""
    sys::System
    """The set of variables of the system."""
    fullvars::Vector{SymbolicT}
    structure::SystemStructure
    extra_eqs::Vector{Equation}
    param_derivative_map::Dict{SymbolicT, SymbolicT}
    no_deriv_params::Set{SymbolicT}
    original_eqs::Vector{Equation}
    """
    Additional user-provided observed equations. The variables calculated here
    are not used in the rest of the system.
    """
    additional_observed::Vector{Equation}
    """
    Corresponding to `fullvars`, marks variables which may not be structurally present in
    any equation according to `structure.graph` but should not be considered as unused.
    This is typically used by variables on the RHS of equations in `additional_observed`,
    and is useful for ensuring the consistency check is valid. For example, a simplification
    pass prior to `StateSelection.check_consistency` may process the equations
    ```julia
    a ~ b
    b ~ c
    c ~ a
    ```
    Into `additional_observed = [a ~ b, c ~ b]`, and thus end up in a state where
    there are no equations and `fullvars = [b]`. The consistency check would consider `b` as
    unused and the system as fully determined, but in reality `b` should be considered
    as used and the system singular.
    """
    always_present::BitVector
    statemachines::Vector{System}
    """
    Source information for each equation in the `TearingState`. `Vector{Symbol}` for each
    equation representing the path of the subsystem to which it belongs. Empty entries
    indicate unknown source. If this field is empty, either the system has no equations
    or source information is unknown.
    """
    eqs_source::Vector{Vector{Symbol}}
end

function Base.show(io::IO, state::TearingState)
    print(io, "TearingState of ", typeof(state.sys))
end

StateSelection.has_equations(::TearingState) = true
StateSelection.equations(ts::TearingState) = equations(ts)

struct EquationsView <: AbstractVector{Equation}
    ts::TearingState
end
MTKBase.equations(ts::TearingState) = EquationsView(ts)
Base.size(ev::EquationsView) = (length(equations(ev.ts.sys)) + length(ev.ts.extra_eqs),)
function Base.getindex(ev::EquationsView, i::Integer)
    eqs = equations(ev.ts.sys)
    if i > length(eqs)
        return ev.ts.extra_eqs[i - length(eqs)]
    end
    return eqs[i]
end
function Base.setindex!(ev::EquationsView, v::Equation, i::Integer)
    eqs = equations(ev.ts.sys)
    if i > length(eqs)
        ev.ts.extra_eqs[i - length(eqs)] = v
    else
        eqs[i] = v
    end
    return ev
end
function Base.push!(ev::EquationsView, eq)
    push!(ev.ts.extra_eqs, eq)
end

function TearingState(sys::System, source_info::Union{Nothing, MTKBase.EquationSourceInformation} = nothing; check::Bool = true, sort_eqs::Bool = true)
    # flatten system
    if source_info === nothing
        sys = MTKBase.flatten(sys)
    else
        @assert isempty(MTKBase.get_systems(sys)) """
        If `source_info` is provided to `TearingState`, the system must be flattened.
        """
    end
    sys = MTKBase.discrete_unknowns_to_parameters(sys)
    sys = MTKBase.discover_globalscoped(sys)
    MTKBase.check_no_parameter_equations(sys)
    iv = MTKBase.get_iv(sys)
    sources = Vector{Symbol}[]
    # flatten array equations
    if source_info === nothing
        eqs = MTKBase.flatten_equations(equations(sys))
    else
        eqs = Equation[]
        @assert length(equations(sys)) == length(source_info.eqs_source) """
        Mismatch between source information provided to `TearingState` and the structure \
        of the system.
        """
        for (eq, src) in zip(equations(sys), source_info.eqs_source)
            scal_eq = MTKBase.flatten_equation(eq)
            append!(eqs, scal_eq)
            for _ in scal_eq
                push!(sources, src)
            end
        end
    end
    original_eqs = copy(eqs)
    neqs = length(eqs)
    param_derivative_map = Dict{SymbolicT, SymbolicT}()
    no_deriv_params = Set{SymbolicT}()
    fullvars = SymbolicT[]
    # * Scalarize unknowns
    dvs = Set{SymbolicT}()
    collect_vars_to_set!(dvs, unknowns(sys))
    ps = Set{SymbolicT}()
    collect_vars_to_set!(ps, parameters(sys; initial_parameters = true))
    # People sometimes pass completed systems to `mtkcompile`, which means the bound
    # parameters are not in `parameters(sys)` above. So add them here.
    if MTKBase.iscomplete(sys)
        collect_vars_to_set!(ps, collect(bound_parameters(sys)))
    end
    browns = Set{SymbolicT}()
    collect_vars_to_set!(browns, brownians(sys))
    var2idx = Dict{SymbolicT, Int}()
    var_types = VariableType[]

    addvar! = AddVar!(var2idx, dvs, fullvars, var_types)

    # build symbolic incidence
    symbolic_incidence = Vector{SymbolicT}[]
    varsbuf = OrderedSet{SymbolicT}()
    auxiliary_vars = OrderedSet{SymbolicT}()
    eqs_to_retain = trues(length(eqs))
    for (i, eq) in enumerate(eqs)
        eq, is_statemachine_equation = canonicalize_eq!(param_derivative_map, no_deriv_params, eqs_to_retain, ps, iv, i, eq)
        empty!(varsbuf)
        SU.search_variables!(varsbuf, eq; is_atomic = MTKBase.OperatorIsAtomic{SU.Operator}())
        incidence = Set{SymbolicT}()
        isalgeq = true
        for v in varsbuf
            # additionally track brownians in fullvars
            if v in browns
                addvar!(v, BROWNIAN)
                push!(incidence, v)
            end

            # TODO: Can we handle this without `isparameter`?
            if v in ps
                if iv isa SymbolicT && is_time_dependent_parameter(v, ps, iv) &&
                   !haskey(param_derivative_map, Differential(iv)(v)) && !(Differential(iv)(v) in no_deriv_params)
                    # Parameter derivatives default to zero - they stay constant
                    # between callbacks
                    param_derivative_map[Differential(iv)(v)] = Symbolics.COMMON_ZERO
                end
                continue
            end

            iv isa SymbolicT && isequal(v, iv) && continue
            iv isa SymbolicT && MTKBase.isdelay(v, iv) && continue

            if !in(v, dvs)
                isvalid = @match v begin
                    BSImpl.Term(; f, args) => f isa Shift || isempty(args) || f isa SU.Operator && is_transparent_operator(f)::Bool
                    _ => false
                end
                v′ = v
                while !isvalid
                    @match v′ begin
                        BSImpl.Term(; f, args) => begin
                            if f isa Differential
                                v′ = args[1]
                            elseif f isa Shift
                                v′ = args[1]
                            else
                                break
                            end
                            if v′ in dvs
                                isvalid = true
                                break
                            end
                        end
                        _ => break
                    end
                end
                if !isvalid
                    throw(ArgumentError("$v is present in the system but $v′ is not an unknown."))
                end

                addvar!(v, VARIABLE)
                @match v begin
                    BSImpl.Term(; f, args) && if f isa SU.Operator &&
                            !(f isa Differential)
                        end => begin
                            it = input_timedomain(f, args)::Vector{InputTimeDomainElT}
                            for (i, td) in enumerate(it)
                                v′ = args[i]
                                SU.isconst(v′) && continue
                                SU.search_variables!(auxiliary_vars, v′; is_atomic = MTKBase.OperatorIsAtomic{SU.Operator}())
                            end
                    end
                    _ => nothing
                end
            end

            isalgeq &= !MTKBase.isdifferential(v)

            sh = SU.shape(v)::SU.ShapeVecT
            if isempty(sh)
                push!(incidence, v)
                addvar!(v, VARIABLE)
            elseif length(sh) == 1
                vv = collect(v)::Vector{SymbolicT}
                union!(incidence, vv)
                for vi in vv
                    addvar!(vi, VARIABLE)
                end
            elseif length(sh) == 2
                vv = collect(v)::Matrix{SymbolicT}
                union!(incidence, vv)
                for vi in vv
                    addvar!(vi, VARIABLE)
                end
            else
                vv = vec(collect(v)::Array{SymbolicT})::Vector{SymbolicT}
                union!(incidence, vv)
                for vi in vv
                    addvar!(vi, VARIABLE)
                end
            end
        end
        if isalgeq || is_statemachine_equation
            eqs[i] = eq
        end
        push!(symbolic_incidence, collect(incidence))
    end

    for v in auxiliary_vars
        if v in ps
            if iv isa SymbolicT && is_time_dependent_parameter(v, ps, iv) &&
                !haskey(param_derivative_map, Differential(iv)(v)) && !(Differential(iv)(v) in no_deriv_params)
                # Parameter derivatives default to zero - they stay constant
                # between callbacks
                param_derivative_map[Differential(iv)(v)] = Symbolics.COMMON_ZERO
            end
            continue
        end

        iv isa SymbolicT && isequal(v, iv) && continue
        iv isa SymbolicT && MTKBase.isdelay(v, iv) && continue

        if !in(v, dvs)
            isvalid = @match v begin
                BSImpl.Term(; f, args) => f isa Shift || isempty(args) || f isa SU.Operator && is_transparent_operator(f)::Bool
                _ => false
            end
            v′ = v
            while !isvalid
                @match v′ begin
                    BSImpl.Term(; f, args) => begin
                        if f isa Differential
                            v′ = args[1]
                        elseif f isa Shift
                            v′ = args[1]
                        else
                            break
                        end
                        if v′ in dvs
                            isvalid = true
                            break
                        end
                    end
                    _ => break
                end
            end
            if !isvalid
                throw(ArgumentError("$v is present in the system but $v′ is not an unknown."))
            end

            addvar!(v, VARIABLE)
            @match v begin
                BSImpl.Term(; f, args) && if f isa SU.Operator &&
                    !(f isa Differential)
                end => begin
                    it = input_timedomain(f, args)::Vector{InputTimeDomainElT}
                    for (i, td) in enumerate(it)
                        v′ = args[i]
                        SU.isconst(v′) && continue
                        SU.search_variables!(auxiliary_vars, v′; is_atomic = MTKBase.OperatorIsAtomic{SU.Operator}())
                    end
                end
                _ => nothing
            end
        end
        sh = SU.shape(v)::SU.ShapeVecT
        if isempty(sh)
            addvar!(v, VARIABLE)
        elseif length(sh) == 1
            vv = collect(v)::Vector{SymbolicT}
            for vi in vv
                addvar!(vi, VARIABLE)
            end
        elseif length(sh) == 2
            vv = collect(v)::Matrix{SymbolicT}
            for vi in vv
                addvar!(vi, VARIABLE)
            end
        else
            vv = vec(collect(v)::Array{SymbolicT})::Vector{SymbolicT}
            for vi in vv
                addvar!(vi, VARIABLE)
            end
        end
    end
    filter!(Base.Fix2(!==, MTKBase.COMMON_NOTHING) ∘ last, param_derivative_map)

    eqs = eqs[eqs_to_retain]
    original_eqs = original_eqs[eqs_to_retain]
    neqs = length(eqs)
    symbolic_incidence = symbolic_incidence[eqs_to_retain]

    if sort_eqs
        # sort equations lexicographically to reduce simplification issues
        # depending on order due to NP-completeness of tearing. Sort on a
        # bounded prefix of the printed form: the full `string` of an equation
        # is exponential in the sharing depth of hash-consed expressions, and
        # ties on the first 4096 bytes keep their original (deterministic)
        # relative order since the default sort is stable.
        sortidxs = Base.sortperm(map(Base.Fix2(bounded_string, 4096), eqs))
        eqs = eqs[sortidxs]
        original_eqs = original_eqs[sortidxs]
        symbolic_incidence = symbolic_incidence[sortidxs]
        if !isempty(sources)
            sources = sources[sortidxs]
        end
    end

    dervaridxs = OrderedSet{Int}()
    add_intermediate_derivatives!(fullvars, dervaridxs, addvar!)
    # Handle shifts - find lowest shift and add intermediates with derivative edges
    ### Handle discrete variables
    add_intermediate_shifts!(fullvars, dervaridxs, var2idx, addvar!, iv)
    # sort `fullvars` such that the mass matrix is as diagonal as possible.
    dervaridxs = collect(dervaridxs)
    fullvars, var_types = sort_fullvars(fullvars, dervaridxs, var_types, iv)
    var2idx = Dict{SymbolicT, Int}(fullvars .=> eachindex(fullvars))
    ndervars = length(dervaridxs)
    # invalidate `dervaridxs`, it is just `1:ndervars`
    dervaridxs = nothing

    # build `var_to_diff`
    var_to_diff = build_var_to_diff(fullvars, ndervars, var2idx, iv)

    # build incidence graph
    graph = build_incidence_graph(length(fullvars), symbolic_incidence, var2idx)

    state_priorities = build_state_priorities(sys, fullvars, var_to_diff)

    # Identify unknowns that do not appear in any equations and are thus not present in
    # `fullvars`. The bindings and initial conditions for these variables should be removed.
    for v in fullvars
        delete!(dvs, v)
        arr, _ = MTKBase.split_indexed_var(v)
        delete!(dvs, arr)
    end
    new_binds = copy(parent(bindings(sys)))
    new_ics = copy(initial_conditions(sys))
    for var in dvs
        arr, _ = MTKBase.split_indexed_var(var)
        delete!(new_binds, arr)
        delete!(new_ics, arr)
    end

    @set! sys.eqs = eqs
    @set! sys.bindings = new_binds
    @set! sys.initial_conditions = new_ics

    eq_to_diff = StateSelection.DiffGraph(nsrcs(graph))

    structure = SystemStructure(complete(var_to_diff), complete(eq_to_diff),
                                complete(graph), nothing, var_types, state_priorities, false)
    return TearingState(sys, fullvars, structure, Equation[], param_derivative_map,
                        no_deriv_params, original_eqs, Equation[], falses(length(fullvars)),
                        typeof(sys)[], sources)
end

function build_state_priorities(sys::System, fullvars::Vector{SymbolicT}, var_to_diff::StateSelection.DiffGraph)
    # Cache the state priorities
    sps = state_priorities(sys)
    var_priorities = Int[]
    sizehint!(var_priorities, length(fullvars))
    for v in fullvars
        arr, _ = MTKBase.split_indexed_var(v)
        push!(var_priorities, get(sps, arr, 0))
    end

    # Propagate priorities up the `var_to_diff` graph. Each variable's final priority is
    # the maximum of priorities of any of its derivatives
    diff_to_var = invview(var_to_diff)
    for i in eachindex(fullvars)
        # Find a variable that is the lowest order derivative
        diff_to_var[i] === nothing || continue
        p = var_priorities[i]
        var::Int = i
        # Iterate through the higher order derivatives and update their priorities
        while true
            p = var_priorities[var] = max(p, var_priorities[var])
            tmp = var_to_diff[var]
            tmp === nothing && break
            var = tmp
        end
    end

    return var_priorities
end

function sort_fullvars(fullvars::Vector{SymbolicT}, dervaridxs::Vector{Int}, var_types::Vector{VariableType}, @nospecialize(iv::Union{SymbolicT, Nothing}))
    if iv === nothing
        return fullvars, var_types
    end
    iv = iv::SymbolicT
    sorted_fullvars = OrderedSet{SymbolicT}(fullvars[dervaridxs])
    var_to_old_var = Dict{SymbolicT, SymbolicT}(zip(fullvars, fullvars))
    for dervaridx in dervaridxs
        dervar = fullvars[dervaridx]
        diffvar = var_to_old_var[lower_order_var(dervar, iv)]
        if !(diffvar in sorted_fullvars)
            push!(sorted_fullvars, diffvar)
        end
    end
    for v in fullvars
        if !(v in sorted_fullvars)
            push!(sorted_fullvars, v)
        end
    end
    new_fullvars = collect(sorted_fullvars)
    sortperm = indexin(new_fullvars, fullvars)
    fullvars = new_fullvars
    var_types = var_types[sortperm]
    return fullvars, var_types
end

function build_var_to_diff(fullvars::Vector{SymbolicT}, ndervars::Int, var2idx::Dict{SymbolicT, Int}, @nospecialize(iv::Union{SymbolicT, Nothing}))
    nvars = length(fullvars)
    var_to_diff = StateSelection.DiffGraph(nvars, true)
    if iv === nothing
        return var_to_diff
    end
    iv = iv::SymbolicT
    for dervaridx in 1:ndervars
        dervar = fullvars[dervaridx]
        diffvar = lower_order_var(dervar, iv)
        diffvaridx = var2idx[diffvar]
        var_to_diff[diffvaridx] = dervaridx
    end
    return var_to_diff
end

function build_incidence_graph(nvars::Int, symbolic_incidence::Vector{Vector{SymbolicT}}, var2idx::Dict{SymbolicT, Int})
    neqs = length(symbolic_incidence)
    graph = BipartiteGraph(neqs, nvars, Val(false))
    for (ie, vars) in enumerate(symbolic_incidence), v in vars
        jv = var2idx[v]
        add_edge!(graph, ie, jv)
    end

    return graph
end

function collect_vars_to_set!(buffer::Set{SymbolicT}, vars::Vector{SymbolicT})
    for x in vars
        push!(buffer, x)
        @match x begin
            BSImpl.Term(; f, args) && if f === getindex end => push!(buffer, args[1])
            _ => nothing
        end
        sh = SU.shape(x)
        sh isa SU.Unknown && continue
        sh = sh::SU.ShapeVecT
        isempty(sh) && continue
        idxs = SU.stable_eachindex(x)
        for i in idxs
            push!(buffer, x[i])
        end
    end
end

function canonicalize_eq!(param_derivative_map::Dict{SymbolicT, SymbolicT}, no_deriv_params::Set{SymbolicT}, eqs_to_retain::BitVector, ps::Set{SymbolicT}, @nospecialize(iv::Union{Nothing, SymbolicT}), i::Int, eq::Equation)
    is_statemachine_equation = false
    lhs = eq.lhs
    rhs = eq.rhs
    @match lhs begin
        BSImpl.Term(; f, args) && if f isa Differential && iv isa SymbolicT && isequal(f.x, iv) &&
                                     is_time_dependent_parameter(args[1], ps, iv)
                                 end => begin
            # parameter derivatives are opted out by specifying `D(p) ~ missing`, but
            # we want to store `nothing` in the map because that means `substitute`
            # will ignore the rule. We will this identify the presence of `eq′.lhs` in
            # the differentiated expression and error.
            if eq.rhs !== MTKBase.COMMON_MISSING
                param_derivative_map[lhs] = rhs
                eq = Symbolics.COMMON_ZERO ~ rhs
            else
                # change the equation if the RHS is `missing` so the rest of this loop works
                eq = Symbolics.COMMON_ZERO ~ Symbolics.COMMON_ZERO
                push!(no_deriv_params, lhs)
                delete!(param_derivative_map, lhs)
            end
            eqs_to_retain[i] = false
        end
        BSImpl.Const(; val) && if val isa StateMachineOperator end => begin
            is_statemachine_equation = true
        end
        BSImpl.Const(;) && if SU._iszero(lhs) end => nothing
        _ => begin
            eq = Symbolics.COMMON_ZERO ~ (rhs - lhs)
        end
    end
    return eq, is_statemachine_equation
end

struct AddVar!
    var2idx::Dict{SymbolicT, Int}
    dvs::Set{SymbolicT}
    fullvars::Vector{SymbolicT}
    var_types::Vector{VariableType}
end

function (avc::AddVar!)(var::SymbolicT, vtype::VariableType)
    idx = get(avc.var2idx, var, nothing)
    idx === nothing || return idx::Int
    push!(avc.dvs, var)
    push!(avc.fullvars, var)
    push!(avc.var_types, vtype)
    return avc.var2idx[var] = length(avc.fullvars)
end

function add_intermediate_derivatives!(fullvars::Vector{SymbolicT}, dervaridxs::OrderedSet{Int}, addvar!::AddVar!)
    for (i, v) in enumerate(fullvars)
        @match v begin
            BSImpl.Term(; f, args) && if f isa Differential end => begin
                @assert f.order isa Int "Only integer derivative order allowed"
                order = f.order::Int
                push!(dervaridxs, i)
                inner = args[1]
                addvar!(inner, VARIABLE)
                for j in 1:(order-1)
                    addvar!(Differential(f.x, j)(inner), VARIABLE)
                end
            end
            _ => nothing
        end
    end
end

function add_intermediate_shifts!(fullvars::Vector{SymbolicT}, dervaridxs::OrderedSet{Int}, var2idx::Dict{SymbolicT, Int}, addvar!::AddVar!, iv::Union{SymbolicT, Nothing})
    lowest_shift = Dict{SymbolicT, Int}()
    for var in fullvars
        @match var begin
            BSImpl.Term(; f, args) && if f isa Shift end => begin
                steps = f.steps
                if steps > 0
                    error("Only non-positive shifts allowed. Found $var with a shift of $steps")
                end
                v = args[1]
                lowest_shift[v] = min(get(lowest_shift, v, 0), steps)
            end
            _ => nothing
        end
    end
    for var in fullvars
        lshift = typemax(Int)
        steps = typemax(Int)
        tt = iv
        v = var
        @match var begin
            BSImpl.Term(; f, args) && if f isa Shift end => begin
                steps = f.steps
                v = args[1]
                lshift = lowest_shift[v]
                tt = f.t
            end
            if haskey(lowest_shift, var) end => begin
                lshift = lowest_shift[var]
                steps = 0
                tt = iv
                v = var
            end
            _ => continue
        end
        if lshift < steps
            push!(dervaridxs, var2idx[var])
        end
        for s in (steps - 1):-1:(lshift + 1)
            sf = Shift(tt, s)
            dvar = sf(v)
            idx = addvar!(dvar, VARIABLE)
            if !(idx in dervaridxs)
                push!(dervaridxs, idx)
            end
        end
    end
end

function lower_order_var(dervar::SymbolicT, t::SymbolicT)
    @match dervar begin
        BSImpl.Term(; f, args) && if f isa Differential end => begin
            order::Int = f.order::Int
            isone(order) && return args[1]
            return Differential(f.x, order - 1)(args[1])
        end
        BSImpl.Term(; f, args) && if f isa Shift end => begin
            step = f.steps - 1
            vv = args[1]
            if step != 0
                diffvar = Shift(f.t, step)(vv)
            else
                diffvar = vv
            end
            return diffvar
        end
        _ => return Shift(t, -1)(dervar)
    end
end

function shift_discrete_system(ts::TearingState)
    # NOTE: `original_eqs` is intentionally not shifted here. This behavior is
    # necessary for hybrid system handling.
    (; fullvars, sys) = ts
    fullvars_set = Set{SymbolicT}(fullvars)
    discvars = OrderedSet{SymbolicT}()
    eqs = equations(sys)
    for eq in eqs
        SU.search_variables!(discvars, eq; is_atomic = MTKBase.OperatorIsAtomic{Union{Sample, Hold, Pre}}())
    end
    iv = MTKBase.get_iv(sys)::SymbolicT
    discmap = Dict{SymbolicT, SymbolicT}()
    for k in discvars
        k in fullvars_set || continue
        MTKBase.isoperator(k, Union{Sample, Hold, Pre}) && continue
        discmap[k] = MTKBase.simplify_shifts(Shift(iv, 1)(k))
    end

    for i in eachindex(fullvars)
        fullvars[i] = MTKBase.simplify_shifts(substitute(
            fullvars[i], discmap; filterer = Symbolics.FPSubFilterer{Union{Sample, Hold, Pre}}()))
    end
    for i in eachindex(eqs)
        eqs[i] = MTKBase.simplify_shifts(substitute(
            eqs[i], discmap; filterer = Symbolics.FPSubFilterer{Union{Sample, Hold, Pre}}()))
    end

    @set! ts.sys.eqs = eqs
    @set! ts.fullvars = fullvars
    return ts
end
